Attribute VB_Name = "modGhostScript"
Option Explicit

Public GsDllLoaded As Long

Public Enum tGhostscriptDevice
 PDFWriter = 0
 PNGWriter = 1
 JPEGWriter = 2
 BMPWriter = 3
 PCXWriter = 4
 TIFFWriter = 5
 PSWriter = 6
 EPSWriter = 7
 TXTWriter = 8
 PDFAWriter = 9
 PDFXWriter = 10
 PSDWriter = 11
 PCLWriter = 12
 RAWWriter = 13
 SVGWriter = 14
End Enum

Public Enum tPDFAFormat
 PDFA1b = 0
 PDFA2b = 1
End Enum

Public Enum ePDFAX
 PDFA = 0
 PDFX = 1
End Enum

Private GSParams() As String
Private GSParamsIndex As Integer

Public GS_ERROR
Public UseReturnPipe

'General
Public GS_PDFDEFAULT
Public GS_COMPATIBILITY
Public GS_AUTOROTATE
Public GS_OVERPRINT
Public GS_ASCII85

'Compression
Public GS_COMPRESSPAGES
Public GS_COMPRESSCOLOR
Public GS_COMPRESSGREY
Public GS_COMPRESSMONO
Public GS_COMPRESSCOLORMETHOD
Public GS_COMPRESSGREYMETHOD
Public GS_COMPRESSMONOMETHOD
Public GS_COMPRESSCOLORVALUE
Public GS_COMPRESSGREYVALUE
Public GS_COMPRESSMONOVALUE
Public GS_COMPRESSCOLORLEVEL
Public GS_COMPRESSGREYLEVEL
Public GS_COMPRESSCOLORAUTO
Public GS_COMPRESSGREYAUTO
Public GS_COLORRESOLUTION
Public GS_GREYRESOLUTION
Public GS_MONORESOLUTION
Public GS_COLORRESAMPLE
Public GS_GREYRESAMPLE
Public GS_MONORESAMPLE
Public GS_COLORRESAMPLEMETHOD
Public GS_GREYRESAMPLEMETHOD
Public GS_MONORESAMPLEMETHOD

'Fonts
Public GS_EMBEDALLFONTS
Public GS_SUBSETFONTS
Public GS_SUBSETFONTPERC
Public GS_KEEPFONTNAMES

'Colors
Public GS_COLORMODEL
Public GS_CMYKTORGB
Public GS_PRESERVEOVERPRINT
Public GS_TRANSFERFUNCTIONS
Public GS_HALFTONE

'Bitmap
Public GS_PNGColorscount
Public GS_JPEGColorscount
Public GS_BMPColorscount
Public GS_PCXColorscount
Public GS_TIFFColorscount
Public GS_JPEGQuality
Public GS_PSDColorscount
Public GS_PCLColorscount
Public GS_RAWColorscount

' Postscript
Public GS_PSLanguageLevel
Public GS_EPSLanguageLevel

'** Begin Declarations for Encrypt PDF
Private Enum EncryptionStrength
   encLow = 40
   encStrong = 128
End Enum

'Security
Private Const SEC_RESERVED0 = 2& + 1&
Private Const SEC_PRINT = 4&
Private Const SEC_MODIFY = 8&
Private Const SEC_COPY = 16&
Private Const SEC_FORM = 32&
Private Const SEC_RESERVED1 = 128& + 256&
'Revision 3 only
Private Const SEC_FILLFORM = 512&
Private Const SEC_SCREENREADERS = 1024&
Private Const SEC_ASSEMBLY = 2048&
Private Const SEC_HQPRINT = 4096&
 
Public Type EncryptData
 InputFile As String
 OutputFile As String
 UserPass As String
 OwnerPass As String
 DisallowPrinting As Boolean
 DisallowModifyContents As Boolean
 DisallowCopy As Boolean
 DisallowModifyAnnotations As Boolean
 AllowFillIn As Boolean '(128 bit only)
 AllowScreenReaders As Boolean '(128 bit only)
 AllowAssembly As Boolean '(128 bit only)
 AllowDegradedPrinting As Boolean '(128 bit only)
 EncryptionLevel As EncryptionStrength
End Type
'** End Declarations for Encrypt PDF

Public GS_OutStr As String, PFXPassword As String

Private ParamCommands As Collection, currentOwnerPassword As String, currentUserPassword As String

Public Sub GSInit(Options As tOptions)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim Rotate(2) As String, Resample(2) As String, ColorModel(2) As String, _
  ColorsPreserveTransfer(1) As String
50030  Dim PNGColorscount(5) As String, JPEGColorscount(1) As String, BMPColorscount(7) As String, _
  PCXColorscount(5) As String, TIFFColorscount(7) As String, _
  PSLanguageLevel(3) As String, PSDColorsCount(1) As String, _
  PCLColorsCount(1) As String, RAWColorsCount(2) As String, _
  PDFDefaultSettings(4) As String
50080
50090  PDFDefaultSettings(0) = "default": PDFDefaultSettings(1) = "screen": PDFDefaultSettings(2) = "ebook"
50100  PDFDefaultSettings(3) = "printer": PDFDefaultSettings(4) = "prepress"
50110  Rotate(0) = "None": Rotate(1) = "All": Rotate(2) = "PageByPage"
50120
50130  Resample(0) = "Bicubic": Resample(1) = "Subsample": Resample(2) = "Average"
50140
50150  ColorModel(0) = "RGB": ColorModel(1) = "CMYK": ColorModel(2) = "Gray"
50160
50170  ColorsPreserveTransfer(0) = "Remove": ColorsPreserveTransfer(1) = "Preserve"
50180
50190  PNGColorscount(0) = "png16m": PNGColorscount(1) = "png256"
50200  PNGColorscount(2) = "png16": PNGColorscount(3) = "pngmono"
50210  PNGColorscount(4) = "pnggray": PNGColorscount(5) = "pngalpha"
50220
50230  JPEGColorscount(0) = "jpeg": JPEGColorscount(1) = "jpeggray"
50240
50250  BMPColorscount(0) = "bmp32b": BMPColorscount(1) = "bmp16m"
50260  BMPColorscount(2) = "bmp256": BMPColorscount(3) = "bmp16"
50270  BMPColorscount(4) = "bmpsep8": BMPColorscount(5) = "bmpsep1"
50280  BMPColorscount(6) = "bmpgray": BMPColorscount(7) = "bmpmono"
50290
50300  PCXColorscount(0) = "pcxcmyk": PCXColorscount(1) = "pcx24b"
50310  PCXColorscount(2) = "pcx256": PCXColorscount(3) = "pcx16"
50320  PCXColorscount(4) = "pcxmono": PCXColorscount(5) = "pcxgray"
50330
50340  TIFFColorscount(0) = "tiff24nc": TIFFColorscount(1) = "tiff12nc"
50350  TIFFColorscount(2) = "tiffcrle": TIFFColorscount(3) = "tiffg3"
50360  TIFFColorscount(4) = "tiffg32d": TIFFColorscount(5) = "tiffg4"
50370  TIFFColorscount(6) = "tifflzw": TIFFColorscount(7) = "tiffpack"
50380
50390  PSLanguageLevel(0) = "1": PSLanguageLevel(1) = "1.5"
50400  PSLanguageLevel(2) = "2": PSLanguageLevel(3) = "3"
50410
50420  PSDColorsCount(0) = "psdcmyk": PSDColorsCount(1) = "psdrgb"
50430  PCLColorsCount(0) = "pxlcolor": PCLColorsCount(1) = "pxlmono"
50440  RAWColorsCount(0) = "bitcmyk": RAWColorsCount(1) = "bitrgb": RAWColorsCount(2) = "bit"
50450
50460  With Options
50470  'General
50480   GS_PDFDEFAULT = PDFDefaultSettings(.PDFGeneralDefault)
50490   GS_COMPATIBILITY = "1." & (.PDFGeneralCompatibility + 2)
50500   GS_AUTOROTATE = Rotate(.PDFGeneralAutorotate)
50510   GS_OVERPRINT = .PDFGeneralOverprint
50520   GS_ASCII85 = Bool2Text(.PDFGeneralASCII85)
50530
50540   'Compression
50550   GS_COMPRESSPAGES = Bool2Text(.PDFCompressionTextCompression)
50560   GS_COMPRESSCOLOR = Bool2Text(.PDFCompressionColorCompression)
50570   GS_COMPRESSGREY = Bool2Text(.PDFCompressionGreyCompression)
50580   GS_COMPRESSMONO = Bool2Text(.PDFCompressionMonoCompression)
50590
50600   SelectColorCompression .PDFCompressionColorCompressionChoice
50610   SelectGreyCompression .PDFCompressionGreyCompressionChoice
50620   SelectMonoCompression .PDFCompressionMonoCompressionChoice
50630
50640   GS_COMPRESSCOLORVALUE = Bool2Text(.PDFCompressionColorCompression)
50650   GS_COMPRESSGREYVALUE = Bool2Text(.PDFCompressionGreyCompression)
50660   GS_COMPRESSMONOVALUE = Bool2Text(.PDFCompressionMonoCompression)
50670
50680   GS_COLORRESOLUTION = .PDFCompressionColorResolution
50690   GS_GREYRESOLUTION = .PDFCompressionGreyResolution
50700   GS_MONORESOLUTION = .PDFCompressionMonoResolution
50710
50720   GS_COLORRESAMPLE = Bool2Text(.PDFCompressionColorResample)
50730   GS_GREYRESAMPLE = Bool2Text(.PDFCompressionGreyResample)
50740   GS_MONORESAMPLE = Bool2Text(.PDFCompressionMonoResample)
50750
50760   GS_COLORRESAMPLEMETHOD = Resample(.PDFCompressionColorResampleChoice)
50770   GS_GREYRESAMPLEMETHOD = Resample(.PDFCompressionGreyResampleChoice)
50780   GS_MONORESAMPLEMETHOD = Resample(.PDFCompressionMonoResampleChoice)
50790
50800   'Fonts
50810   GS_EMBEDALLFONTS = Bool2Text(.PDFFontsEmbedAll)
50820   GS_SUBSETFONTS = Bool2Text(.PDFFontsSubSetFonts)
50830   GS_SUBSETFONTPERC = .PDFFontsSubSetFontsPercent
50840
50850   'Colors
50860   GS_COLORMODEL = ColorModel(.PDFColorsColorModel)
50870   GS_CMYKTORGB = Bool2Text(.PDFColorsCMYKToRGB)
50880   GS_PRESERVEOVERPRINT = Bool2Text(.PDFColorsPreserveOverprint)
50890   GS_TRANSFERFUNCTIONS = ColorsPreserveTransfer(.PDFColorsPreserveTransfer)
50900   GS_HALFTONE = Bool2Text(.PDFColorsPreserveHalftone)
50910
50920   'Bitmap
50930   GS_PNGColorscount = PNGColorscount(.PNGColorscount)
50940   GS_JPEGColorscount = JPEGColorscount(.JPEGColorscount)
50950   GS_BMPColorscount = BMPColorscount(.BMPColorscount)
50960   GS_PCXColorscount = PCXColorscount(.PCXColorscount)
50970   GS_TIFFColorscount = TIFFColorscount(.TIFFColorscount)
50980   GS_JPEGQuality = .JPEGQuality
50990   GS_PSLanguageLevel = PSLanguageLevel(.PSLanguageLevel)
51000   GS_EPSLanguageLevel = PSLanguageLevel(.EPSLanguageLevel)
51010   GS_PSDColorscount = PSDColorsCount(.PSDColorsCount)
51020   GS_PCLColorscount = PCLColorsCount(.PCLColorsCount)
51030   GS_RAWColorscount = RAWColorsCount(.RAWColorsCount)
51040  End With
51050  'Other
51060  GS_ERROR = 0
51070  UseReturnPipe = 1
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "GSInit")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Function CallGhostscript(Comment As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim LastStop As Currency, res As Boolean, c As Currency, Ghostscript As clsGhostscript, GSParameters() As String, _
  i As Long
50030  If PerformanceTimer Then
50040   LastStop = ExactTimer_Value()
50050  End If
50060  Set Ghostscript = GetGhostscriptVersion
50070  ReDim GSParameters(UBound(GSParams))
50080  For i = LBound(GSParams) To UBound(GSParams)
50090   If ((Ghostscript.VersionMajor > 9) Or (Ghostscript.VersionMajor = 9 And Ghostscript.VersionMinor > 7)) Then
50100    GSParameters(i) = EncodeToUTF8(GSParams(i))
50110   Else
50120    GSParameters(i) = GSParams(i)
50130   End If
50140  Next i
50150  res = CallGS(GSParameters)
50160  If PerformanceTimer Then
50170    c = ExactTimer_Value() - LastStop
50180    IfLoggingWriteLogfile "Time for converting [" & Comment & "]: " & _
    Format$(Int(c) * (1 / 86400), "hh:nn:ss:") & Format$(((c) - Int(c)) * 1000, "000")
50200   Else
50210    IfLoggingWriteLogfile "Time for converting -> No performance timer [" & Comment & "]"
50220  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CallGhostscript")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Sub AddInputFiles(InfoSpoolFileName As String, AdditionalFiles As Collection)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim Path As String, spoolFileName As String, isf As clsInfoSpoolFile, isfi As clsInfoSpoolFileInfo, i As Long
50020  AddParams "-f"
50030  If Not (AdditionalFiles Is Nothing) Then
50040   For i = 1 To AdditionalFiles.Count
50050    If LenB(AdditionalFiles(i)) > 0 Then
50060     If FileExists(AdditionalFiles(i)) Then
50070      AddParams AdditionalFiles(i)
50080     End If
50090    End If
50100   Next i
50110  End If
50120  Set isf = New clsInfoSpoolFile
50130  isf.ReadInfoFile InfoSpoolFileName
50140  For i = 1 To isf.InfoFiles.Count
50150   Set isfi = isf.InfoFiles(i)
50160   SplitPath isfi.spoolFileName, , Path
50170   If LenB(Path) = 0 Then
50180    spoolFileName = CompleteSpoolFileName(InfoSpoolFileName, isfi.spoolFileName)
50190   Else
50200    spoolFileName = isfi.spoolFileName
50210   End If
50220   If FileExists(spoolFileName) Then
50230    AddParams spoolFileName
50240   End If
50250  Next i
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "AddInputFiles")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Function CreatePDF(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String, PDFDocViewFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String, encPDF As EncryptData, tEnc As Boolean, Ghostscript As clsGhostscript
50020
50030  InitParams
50040  Set ParamCommands = New Collection
50050
50060 ' If Options.OneFilePerPage = 1 Then
50070 '  GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50080 ' End If
50090
50100  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50110
50120  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50130   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50140  End If
50150  AddParams "-I" & tStr
50160  AddParams "-q"
50170  AddParams "-dNOPAUSE"
50180  AddParams "-dBATCH"
50190  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50200   AddParams "-sFONTPATH=" & GetFontsDirectory
50210  End If
50220  AddParams "-sDEVICE=pdfwrite"
50230  If Options.DontUseDocumentSettings = 0 Then
50240   AddParams "-dPDFSETTINGS=/" & GS_PDFDEFAULT
50250   AddParams "-dCompatibilityLevel=" & GS_COMPATIBILITY
50260   AddParams "-dProcessColorModel=/Device" & GS_COLORMODEL
50270   AddParams "-dAutoRotatePages=/" & GS_AUTOROTATE
50280   AddParams "-dCompressPages=" & GS_COMPRESSPAGES
50290   AddParams "-dEmbedAllFonts=" & GS_EMBEDALLFONTS
50300   AddParams "-dSubsetFonts=" & GS_SUBSETFONTS
50310   AddParams "-dMaxSubsetPct=" & GS_SUBSETFONTPERC
50320   AddParams "-dConvertCMYKImagesToRGB=" & GS_CMYKTORGB
50330
50340   Set Ghostscript = GetGhostscriptVersion
50350   If Options.PDFOptimize = 1 And ((Ghostscript.VersionMajor > 9) Or (Ghostscript.VersionMajor = 9 And Ghostscript.VersionMinor >= 7)) Then
50360    AddParams "-dFastWebView"
50370   End If
50380
50390   If Options.UseFixPapersize <> 0 Then
50400    If Options.UseCustomPaperSize = 0 Then
50410      If LenB(Trim$(Options.Papersize)) > 0 Then
50420       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50430       AddParams "-dFIXEDMEDIA"
50440       AddParams "-dNORANGEPAGESIZE"
50450      End If
50460     Else
50470      If Options.DeviceWidthPoints >= 1 Then
50480       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50490      End If
50500      If Options.DeviceHeightPoints >= 1 Then
50510       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50520      End If
50530      If Options.DeviceWidthPoints >= 1 Or Options.DeviceHeightPoints >= 1 Then
50540       AddParams "-dFIXEDMEDIA"
50550      End If
50560    End If
50570   End If
50580  End If
50590  tEnc = False
50600  If Options.PDFOptimize = 0 And Options.PDFUseSecurity <> 0 And SecurityIsPossible = True Then
50610   If Options.PDFAes128Encryption = 0 Then
50620    If SetEncryptionParams(encPDF, "", "") = True Then
50630     tEnc = True
50640     If Len(encPDF.OwnerPass) > 0 Then
50650       AddParams "-sOwnerPassword=" & encPDF.OwnerPass
50660       currentOwnerPassword = encPDF.OwnerPass
50670      Else
50680       If Len(encPDF.UserPass) > 0 Then
50690        AddParams "-sOwnerPassword=" & encPDF.UserPass
50700        currentOwnerPassword = encPDF.OwnerPass
50710       End If
50720     End If
50730     If Len(encPDF.UserPass) > 0 Then
50740      AddParams "-sUserPassword=" & encPDF.UserPass
50750      currentUserPassword = encPDF.UserPass
50760     End If
50770     AddParams "-dPermissions=" & CalculatePermissions(encPDF)
50780     If (GS_COMPATIBILITY = "1.4" Or GS_COMPATIBILITY = "1.5") And encPDF.EncryptionLevel <> encLow Then
50790       AddParams "-dEncryptionR=3"
50800       AddParams "-dKeyLength=128"
50810      Else
50820       AddParams "-dEncryptionR=2"
50830       AddParams "-dKeyLength=40"
50840     End If
50850    Else
50860     If Options.UseAutosave = 0 Then
50870      MsgBox LanguageStrings.MessagesMsg23, vbCritical
50880     End If
50890    End If
50900   End If
50910  End If
50920
50930  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50940   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50950  End If
50960  AddParams "-sOutputFile=" & GSOutputFile
50970
50980  If Options.DontUseDocumentSettings = 0 Then
50990   SetColorParams
51000   SetGreyParams
51010   SetMonoParams
51020
51030   AddParams "-dPreserveOverprintSettings=" & GS_PRESERVEOVERPRINT
51040   AddParams "-dUCRandBGInfo=/Preserve"
51050   AddParams "-dUseFlateCompression=true"
51060   AddParams "-dParseDSCCommentsForDocInfo=true"
51070   AddParams "-dParseDSCComments=true"
51080   AddParams "-dOPM=" & GS_OVERPRINT
51090   AddParams "-dOffOptimizations=0"
51100   AddParams "-dLockDistillerParams=false"
51110   AddParams "-dGrayImageDepth=-1"
51120   AddParams "-dASCII85EncodePages=" & GS_ASCII85
51130   AddParams "-dDefaultRenderingIntent=/Default"
51140   AddParams "-dTransferFunctionInfo=/" & GS_TRANSFERFUNCTIONS
51150   AddParams "-dPreserveHalftoneInfo=" & GS_HALFTONE
51160   AddParams "-dDetectBlends=true"
51170
51180   AddAdditionalGhostscriptParameters
51190
51200   AddParamCommands
51210  End If
51220
51230  Dim AdditionalFiles As Collection
51240  Set AdditionalFiles = New Collection
51250  AdditionalFiles.Add PDFDocInfoFile
51260  AdditionalFiles.Add StampFile
51270  AdditionalFiles.Add PDFDocViewFile
51280
51290  AddInputFiles InfoSpoolFileName, AdditionalFiles
51300
51310  ShowParams
51320  If tEnc = True Then
51330    CallGhostscript "PDF with encryption"
51340   Else
51350    CallGhostscript "PDF without encryption"
51360  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePDF")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePNG(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_PNGColorscount
50250
50260  If Options.DontUseDocumentSettings = 0 Then
50270   If Options.UseFixPapersize <> 0 Then
50280    If Options.UseCustomPaperSize = 0 Then
50290      If LenB(Trim$(Options.Papersize)) > 0 Then
50300       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50310       AddParams "-dFIXEDMEDIA"
50320       AddParams "-dNORANGEPAGESIZE"
50330      End If
50340     Else
50350      If Options.DeviceWidthPoints >= 1 Then
50360       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50370      End If
50380      If Options.DeviceHeightPoints >= 1 Then
50390       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50400      End If
50410    End If
50420   End If
50430   AddParams "-r" & Options.PNGResolution & "x" & Options.PNGResolution
50440
50450   If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460    GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470   End If
50480   AddParams "-sOutputFile=" & GSOutputFile
50490  End If
50500
50510  AddAdditionalGhostscriptParameters
50520
50530  Dim AdditionalFiles As Collection
50540  Set AdditionalFiles = New Collection
50550  AdditionalFiles.Add PDFDocInfoFile
50560  AdditionalFiles.Add StampFile
50570
50580  AddInputFiles InfoSpoolFileName, AdditionalFiles
50590
50600  ShowParams
50610  CallGhostscript "PNG"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePNG")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateJPEG(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_JPEGColorscount
50250  If Options.DontUseDocumentSettings = 0 Then
50260   AddParams "-dJPEGQ=" & GS_JPEGQuality
50270   If Options.UseFixPapersize <> 0 Then
50280    If Options.UseCustomPaperSize = 0 Then
50290      If LenB(Trim$(Options.Papersize)) > 0 Then
50300       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50310       AddParams "-dFIXEDMEDIA"
50320       AddParams "-dNORANGEPAGESIZE"
50330      End If
50340     Else
50350      If Options.DeviceWidthPoints >= 1 Then
50360       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50370      End If
50380      If Options.DeviceHeightPoints >= 1 Then
50390       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50400      End If
50410    End If
50420   End If
50430   AddParams "-r" & Options.JPEGResolution & "x" & Options.JPEGResolution
50440
50450   If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460    GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470   End If
50480   AddParams "-sOutputFile=" & GSOutputFile
50490  End If
50500
50510  AddAdditionalGhostscriptParameters
50520
50530  Dim AdditionalFiles As Collection
50540  Set AdditionalFiles = New Collection
50550  AdditionalFiles.Add PDFDocInfoFile
50560  AdditionalFiles.Add StampFile
50570
50580  AddInputFiles InfoSpoolFileName, AdditionalFiles
50590
50600  ShowParams
50610  CallGhostscript "JPEG"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateJPEG")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateBMP(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_BMPColorscount
50250
50260  If Options.DontUseDocumentSettings = 0 Then
50270   If Options.UseFixPapersize <> 0 Then
50280    If Options.UseCustomPaperSize = 0 Then
50290      If LenB(Trim$(Options.Papersize)) > 0 Then
50300       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50310       AddParams "-dFIXEDMEDIA"
50320       AddParams "-dNORANGEPAGESIZE"
50330      End If
50340     Else
50350      If Options.DeviceWidthPoints >= 1 Then
50360       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50370      End If
50380      If Options.DeviceHeightPoints >= 1 Then
50390       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50400      End If
50410    End If
50420   End If
50430   AddParams "-r" & Options.BMPResolution & "x" & Options.BMPResolution
50440  End If
50450
50460  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50470   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50480  End If
50490  AddParams "-sOutputFile=" & GSOutputFile
50500
50510  AddAdditionalGhostscriptParameters
50520
50530  Dim AdditionalFiles As Collection
50540  Set AdditionalFiles = New Collection
50550  AdditionalFiles.Add PDFDocInfoFile
50560  AdditionalFiles.Add StampFile
50570
50580  AddInputFiles InfoSpoolFileName, AdditionalFiles
50590
50600  ShowParams
50610  CallGhostscript "BMP"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateBMP")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePCX(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_PCXColorscount
50250  If Options.DontUseDocumentSettings = 0 Then
50260   If Options.UseFixPapersize <> 0 Then
50270    If Options.UseCustomPaperSize = 0 Then
50280      If LenB(Trim$(Options.Papersize)) > 0 Then
50290       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50300       AddParams "-dFIXEDMEDIA"
50310       AddParams "-dNORANGEPAGESIZE"
50320      End If
50330     Else
50340      If Options.DeviceWidthPoints >= 1 Then
50350       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50360      End If
50370      If Options.DeviceHeightPoints >= 1 Then
50380       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50390      End If
50400    End If
50410   End If
50420   AddParams "-r" & Options.PCXResolution & "x" & Options.PCXResolution
50430  End If
50440
50450  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470  End If
50480  AddParams "-sOutputFile=" & GSOutputFile
50490
50500  AddAdditionalGhostscriptParameters
50510
50520  Dim AdditionalFiles As Collection
50530  Set AdditionalFiles = New Collection
50540  AdditionalFiles.Add PDFDocInfoFile
50550  AdditionalFiles.Add StampFile
50560
50570  AddInputFiles InfoSpoolFileName, AdditionalFiles
50580
50590  ShowParams
50600  CallGhostscript "PCX"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePCX")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateTIFF(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_TIFFColorscount
50250  If Options.DontUseDocumentSettings = 0 Then
50260   If Options.UseFixPapersize <> 0 Then
50270    If Options.UseCustomPaperSize = 0 Then
50280      If LenB(Trim$(Options.Papersize)) > 0 Then
50290       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50300       AddParams "-dFIXEDMEDIA"
50310       AddParams "-dNORANGEPAGESIZE"
50320      End If
50330     Else
50340      If Options.DeviceWidthPoints >= 1 Then
50350       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50360      End If
50370      If Options.DeviceHeightPoints >= 1 Then
50380       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50390      End If
50400    End If
50410   End If
50420   AddParams "-r" & Options.TIFFResolution & "x" & Options.TIFFResolution
50430  End If
50440
50450  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470  End If
50480  AddParams "-sOutputFile=" & GSOutputFile
50490
50500  AddAdditionalGhostscriptParameters
50510
50520  Dim AdditionalFiles As Collection
50530  Set AdditionalFiles = New Collection
50540  AdditionalFiles.Add PDFDocInfoFile
50550  AdditionalFiles.Add StampFile
50560
50570  AddInputFiles InfoSpoolFileName, AdditionalFiles
50580
50590  ShowParams
50600  CallGhostscript "TIFF"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateTIFF")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePS(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String, Ghostscript As clsGhostscript
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  Set Ghostscript = GetGhostscriptVersion
50250  If (Ghostscript.VersionMajor < 9) Then
50260    AddParams "-sDEVICE=pswrite"
50270   Else
50280    AddParams "-sDEVICE=ps2write"
50290  End If
50300
50310  If Options.DontUseDocumentSettings = 0 Then
50320   If Options.UseFixPapersize <> 0 Then
50330    If Options.UseCustomPaperSize = 0 Then
50340      If LenB(Trim$(Options.Papersize)) > 0 Then
50350       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50360       AddParams "-dFIXEDMEDIA"
50370       AddParams "-dNORANGEPAGESIZE"
50380      End If
50390     Else
50400      If Options.DeviceWidthPoints >= 1 Then
50410       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50420      End If
50430      If Options.DeviceHeightPoints >= 1 Then
50440       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50450      End If
50460    End If
50470   End If
50480   AddParams "-dLanguageLevel=" & GS_PSLanguageLevel
50490  End If
50500
50510  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50520   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50530  End If
50540  AddParams "-sOutputFile=" & GSOutputFile
50550
50560  AddAdditionalGhostscriptParameters
50570
50580  Dim AdditionalFiles As Collection
50590  Set AdditionalFiles = New Collection
50600  AdditionalFiles.Add PDFDocInfoFile
50610  AdditionalFiles.Add StampFile
50620
50630  AddInputFiles InfoSpoolFileName, AdditionalFiles
50640
50650  ShowParams
50660  CallGhostscript "PS"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePS")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateEPS(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=epswrite"
50250  If Options.DontUseDocumentSettings = 0 Then
50260   If Options.UseFixPapersize <> 0 Then
50270    If Options.UseCustomPaperSize = 0 Then
50280      If LenB(Trim$(Options.Papersize)) > 0 Then
50290       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50300       AddParams "-dFIXEDMEDIA"
50310       AddParams "-dNORANGEPAGESIZE"
50320      End If
50330     Else
50340      If Options.DeviceWidthPoints >= 1 Then
50350       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50360      End If
50370      If Options.DeviceHeightPoints >= 1 Then
50380       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50390      End If
50400    End If
50410   End If
50420   AddParams "-dLanguageLevel=" & GS_EPSLanguageLevel
50430  End If
50440
50450  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470  End If
50480  AddParams "-sOutputFile=" & GSOutputFile
50490
50500  AddAdditionalGhostscriptParameters
50510
50520  Dim AdditionalFiles As Collection
50530  Set AdditionalFiles = New Collection
50540  AdditionalFiles.Add PDFDocInfoFile
50550  AdditionalFiles.Add StampFile
50560
50570  AddInputFiles InfoSpoolFileName, AdditionalFiles
50580
50590  ShowParams
50600  CallGhostscript "EPS"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateEPS")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateTXT(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String, Path As String, spoolFileName As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  AddParams "-dNODISPLAY"
50210  AddParams "-dDELAYBIND"
50220  AddParams "-dWRITESYSTEMDICT"
50230  AddParams "-dSIMPLE"
50240  AddParams "ps2ascii.ps"
50250
50260  If LenB(StampFile) > 0 Then
50270   If FileExists(StampFile) Then
50280    AddParams StampFile
50290   End If
50300  End If
50310  Dim isf As clsInfoSpoolFile, isfi As clsInfoSpoolFileInfo, i As Long
50320  Set isf = New clsInfoSpoolFile
50330  isf.ReadInfoFile InfoSpoolFileName
50340  For i = 1 To isf.InfoFiles.Count
50350   Set isfi = isf.InfoFiles(i)
50360   SplitPath isfi.spoolFileName, , Path
50370   If LenB(Path) = 0 Then
50380     spoolFileName = CompleteSpoolFileName(InfoSpoolFileName, isfi.spoolFileName)
50390    Else
50400     spoolFileName = isfi.spoolFileName
50410   End If
50420   If FileExists(spoolFileName) Then
50430    AddParams spoolFileName
50440   End If
50450  Next i
50460  If LenB(PDFDocInfoFile) > 0 Then
50470   If FileExists(PDFDocInfoFile) Then
50480    AddParams PDFDocInfoFile
50490   End If
50500  End If
50510
50520  ShowParams
50530  CallGhostscript "TXT"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateTXT")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePDFAXDefFile(pdfType As ePDFAX, PDFColorsColorModel As Long, InfoSpoolFileName As String) As String
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim filename As String, iccFileName As String, ressource As String, Path As String, File As String
50020
50030  SplitPath InfoSpoolFileName, , Path, , File
50040  filename = CompletePath(Path) & File & ".def"
50050
50060  If pdfType = PDFA Then
50070   ressource = StrConv(LoadResData(101, "PDFA"), vbUnicode)
50080  End If
50090  If pdfType = PDFX Then
50100   ressource = StrConv(LoadResData(101, "PDFX"), vbUnicode)
50110  End If
50120
50130  If PDFColorsColorModel = 0 Then 'RGB
50140   iccFileName = Replace$(CompletePath(Options.DirectoryGhostscriptLibraries) & "eciRGB_v2.icc", "\", "/", 1)
50150  ElseIf Options.PDFColorsColorModel = 1 Then 'CMYK
50160   iccFileName = Replace$(CompletePath(Options.DirectoryGhostscriptLibraries) & "ISOcoated_v2_300_eci.icc", "\", "/", 1)
50170  Else 'GRAY
50180   iccFileName = Replace$(CompletePath(Options.DirectoryGhostscriptLibraries) & "eciRGB_v2.icc", "\", "/")
50190  End If
50200
50210  ressource = Replace$(ressource, "[PATH]", iccFileName, 1, 1, vbTextCompare)
50220  CreateTextFile filename, ressource
50230  CreatePDFAXDefFile = filename
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePDFAXDefFile")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePDFA(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String, PDFDocViewFile As String, PDFAFormat As tPDFAFormat)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  InitParams
50040  Set ParamCommands = New Collection
50050
50060 ' If Options.OneFilePerPage = 1 Then
50070 '  GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50080 ' End If
50090
50100  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50110
50120  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50130   If DirExists(Options.AdditionalGhostscriptSearchpath) Then
50140    tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150   End If
50160  End If
50170  AddParams "-I" & tStr
50180  If PDFAFormat = PDFA1b Then
50190    AddParams "-dPDFA=1"
50200   ElseIf PDFAFormat = PDFA2b Then
50210    AddParams "-dPDFA=2"
50220   Else
50230    AddParams "-dPDFA"
50240  End If
50250  AddParams "-q"
50260  AddParams "-dNOPAUSE"
50270  AddParams "-dBATCH"
50280  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50290   AddParams "-sFONTPATH=" & GetFontsDirectory
50300  End If
50310  AddParams "-sDEVICE=pdfwrite"
50320  If Options.DontUseDocumentSettings = 0 Then
50330   AddParams "-dPDFSETTINGS=/" & GS_PDFDEFAULT
50340   AddParams "-dCompatibilityLevel=" & GS_COMPATIBILITY
50350   AddParams "-dNOOUTERSAVE"
50360   AddParams "-dUseCIEColor"
50370   AddParams "-sProcessColorModel=Device" & GS_COLORMODEL
50380   AddParams "-dAutoRotatePages=/" & GS_AUTOROTATE
50390   AddParams "-dCompressPages=" & GS_COMPRESSPAGES
50400   AddParams "-dEmbedAllFonts=true"
50410   AddParams "-dSubsetFonts=" & GS_SUBSETFONTS
50420   AddParams "-dMaxSubsetPct=100"
50430   AddParams "-dConvertCMYKImagesToRGB=" & GS_CMYKTORGB
50440
50450   If Options.UseFixPapersize <> 0 Then
50460    If Options.UseCustomPaperSize = 0 Then
50470      If LenB(Trim$(Options.Papersize)) > 0 Then
50480       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50490       AddParams "-dFIXEDMEDIA"
50500       AddParams "-dNORANGEPAGESIZE"
50510      End If
50520     Else
50530      If Options.DeviceWidthPoints >= 1 Then
50540       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50550      End If
50560      If Options.DeviceHeightPoints >= 1 Then
50570       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50580      End If
50590    End If
50600   End If
50610  End If
50620
50630  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50640   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50650  End If
50660  AddParams "-sOutputFile=" & GSOutputFile
50670
50680  If Options.DontUseDocumentSettings = 0 Then
50690   SetColorParams
50700   SetGreyParams
50710   SetMonoParams
50720
50730   AddParams "-dPreserveOverprintSettings=" & GS_PRESERVEOVERPRINT
50740   AddParams "-dUCRandBGInfo=/Preserve"
50750   AddParams "-dUseFlateCompression=true"
50760   AddParams "-dParseDSCCommentsForDocInfo=true"
50770   AddParams "-dParseDSCComments=true"
50780   AddParams "-dOPM=1" '& GS_OVERPRINT
50790   AddParams "-dOffOptimizations=0"
50800   AddParams "-dLockDistillerParams=false"
50810   AddParams "-dGrayImageDepth=-1"
50820   AddParams "-dASCII85EncodePages=" & GS_ASCII85
50830   AddParams "-dDefaultRenderingIntent=/Default"
50840   AddParams "-dTransferFunctionInfo=/" & GS_TRANSFERFUNCTIONS
50850   AddParams "-dPreserveHalftoneInfo=" & GS_HALFTONE
50860   AddParams "-dDetectBlends=true"
50870
50880   AddAdditionalGhostscriptParameters
50890
50900   AddParamCommands
50910  End If
50920
50930  Dim AdditionalFiles As Collection
50940  Set AdditionalFiles = New Collection
50950 '50950  AdditionalFiles.Add CreatePDFAXDefFile(PDFA, Options.PDFColorsColorModel, InfoSpoolFileName)
50960  AdditionalFiles.Add PDFDocInfoFile
50970  AdditionalFiles.Add StampFile
50980  AdditionalFiles.Add PDFDocViewFile
50990
51000  AddInputFiles InfoSpoolFileName, AdditionalFiles
51010
51020  ShowParams
51030  CallGhostscript "PDF/A (without encryption)"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePDFA")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePDFX(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String, PDFDocViewFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  InitParams
50040  Set ParamCommands = New Collection
50050
50060 ' If Options.OneFilePerPage = 1 Then
50070 '  GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50080 ' End If
50090
50100  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50110
50120  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50130   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50140  End If
50150  AddParams "-I" & tStr
50160  AddParams "-q"
50170  AddParams "-dNOPAUSE"
50180  AddParams "-dBATCH"
50190  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50200   AddParams "-sFONTPATH=" & GetFontsDirectory
50210  End If
50220  AddParams "-sDEVICE=pdfwrite"
50230  If Options.DontUseDocumentSettings = 0 Then
50240   AddParams "-dPDFSETTINGS=/" & GS_PDFDEFAULT
50250   AddParams "-dCompatibilityLevel=" & GS_COMPATIBILITY
50260   If GS_COLORMODEL = "RGB" Then ' RGB not allowed for PDFX
50270    AddParams "-dProcessColorModel=/DeviceCMYK"
50280   Else
50290    AddParams "-sProcessColorModel=Device" & GS_COLORMODEL
50300   End If
50310   AddParams "-dAutoRotatePages=/" & GS_AUTOROTATE
50320   AddParams "-dCompressPages=" & GS_COMPRESSPAGES
50330   AddParams "-dEmbedAllFonts=" & GS_EMBEDALLFONTS
50340   AddParams "-dSubsetFonts=" & GS_SUBSETFONTS
50350   AddParams "-dMaxSubsetPct=" & GS_SUBSETFONTPERC
50360   AddParams "-dConvertCMYKImagesToRGB=" & GS_CMYKTORGB
50370
50380   If Options.UseFixPapersize <> 0 Then
50390    If Options.UseCustomPaperSize = 0 Then
50400      If LenB(Trim$(Options.Papersize)) > 0 Then
50410       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50420       AddParams "-dFIXEDMEDIA"
50430       AddParams "-dNORANGEPAGESIZE"
50440      End If
50450     Else
50460      If Options.DeviceWidthPoints >= 1 Then
50470       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50480      End If
50490      If Options.DeviceHeightPoints >= 1 Then
50500       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50510      End If
50520    End If
50530   End If
50540
50550  End If
50560
50570  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50580   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50590  End If
50600  AddParams "-sOutputFile=" & GSOutputFile
50610
50620  If Options.DontUseDocumentSettings = 0 Then
50630   SetColorParams
50640   SetGreyParams
50650   SetMonoParams
50660
50670   AddParams "-dPreserveOverprintSettings=" & GS_PRESERVEOVERPRINT
50680   AddParams "-dUCRandBGInfo=/Preserve"
50690   AddParams "-dUseFlateCompression=true"
50700   AddParams "-dParseDSCCommentsForDocInfo=true"
50710   AddParams "-dParseDSCComments=true"
50720   AddParams "-dOPM=" & GS_OVERPRINT
50730   AddParams "-dOffOptimizations=0"
50740   AddParams "-dLockDistillerParams=false"
50750   AddParams "-dGrayImageDepth=-1"
50760   AddParams "-dASCII85EncodePages=" & GS_ASCII85
50770   AddParams "-dDefaultRenderingIntent=/Default"
50780   AddParams "-dTransferFunctionInfo=/" & GS_TRANSFERFUNCTIONS
50790   AddParams "-dPreserveHalftoneInfo=" & GS_HALFTONE
50800   AddParams "-dDetectBlends=true"
50810
50820   AddAdditionalGhostscriptParameters
50830
50840   AddParams "-dPDFX"
50850   AddParams "-f"
50860
50870   AddParamCommands
50880  End If
50890
50900  Dim AdditionalFiles As Collection
50910  Set AdditionalFiles = New Collection
50920 '50920  If GS_COLORMODEL = "RGB" Then ' RGB not allowed for PDFX
50930 '50930   AdditionalFiles.Add CreatePDFAXDefFile(PDFX, 1, InfoSpoolFileName)
50940 '50940  Else
50950 '50950   AdditionalFiles.Add CreatePDFAXDefFile(PDFX, Options.PDFColorsColorModel, InfoSpoolFileName)
50960 '50960  End If
50970  AdditionalFiles.Add PDFDocInfoFile
50980  AdditionalFiles.Add StampFile
50990  AdditionalFiles.Add PDFDocViewFile
51000
51010  AddInputFiles InfoSpoolFileName, AdditionalFiles
51020
51030  ShowParams
51040  CallGhostscript "PDF/X (without encryption)"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePDFX")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePSD(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_PSDColorscount
50250  If Options.DontUseDocumentSettings = 0 Then
50260   If Options.UseFixPapersize <> 0 Then
50270    If Options.UseCustomPaperSize = 0 Then
50280      If LenB(Trim$(Options.Papersize)) > 0 Then
50290       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50300       AddParams "-dFIXEDMEDIA"
50310       AddParams "-dNORANGEPAGESIZE"
50320      End If
50330     Else
50340      If Options.DeviceWidthPoints >= 1 Then
50350       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50360      End If
50370      If Options.DeviceHeightPoints >= 1 Then
50380       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50390      End If
50400    End If
50410   End If
50420   AddParams "-r" & Options.PSDResolution & "x" & Options.PSDResolution
50430  End If
50440
50450  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470  End If
50480  AddParams "-sOutputFile=" & GSOutputFile
50490
50500  AddAdditionalGhostscriptParameters
50510
50520  Dim AdditionalFiles As Collection
50530  Set AdditionalFiles = New Collection
50540  AdditionalFiles.Add PDFDocInfoFile
50550  AdditionalFiles.Add StampFile
50560
50570  AddInputFiles InfoSpoolFileName, AdditionalFiles
50580
50590  ShowParams
50600  CallGhostscript "PSD"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePSD")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreatePCL(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_PCLColorscount
50250  If Options.DontUseDocumentSettings = 0 Then
50260   If Options.UseFixPapersize <> 0 Then
50270    If Options.UseCustomPaperSize = 0 Then
50280      If LenB(Trim$(Options.Papersize)) > 0 Then
50290       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50300       AddParams "-dFIXEDMEDIA"
50310       AddParams "-dNORANGEPAGESIZE"
50320      End If
50330     Else
50340      If Options.DeviceWidthPoints >= 1 Then
50350       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50360      End If
50370      If Options.DeviceHeightPoints >= 1 Then
50380       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50390      End If
50400    End If
50410   End If
50420   AddParams "-r" & Options.PCLResolution & "x" & Options.PCLResolution
50430  End If
50440
50450  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470  End If
50480  AddParams "-sOutputFile=" & GSOutputFile
50490
50500  AddAdditionalGhostscriptParameters
50510
50520  Dim AdditionalFiles As Collection
50530  Set AdditionalFiles = New Collection
50540  AdditionalFiles.Add PDFDocInfoFile
50550  AdditionalFiles.Add StampFile
50560
50570  AddInputFiles InfoSpoolFileName, AdditionalFiles
50580
50590  ShowParams
50600  CallGhostscript "PCL"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreatePCL")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateRAW(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50210   AddParams "-sFONTPATH=" & GetFontsDirectory
50220  End If
50230
50240  AddParams "-sDEVICE=" & GS_RAWColorscount
50250  If Options.DontUseDocumentSettings = 0 Then
50260   If Options.UseFixPapersize <> 0 Then
50270    If Options.UseCustomPaperSize = 0 Then
50280      If LenB(Trim$(Options.Papersize)) > 0 Then
50290       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50300       AddParams "-dFIXEDMEDIA"
50310       AddParams "-dNORANGEPAGESIZE"
50320      End If
50330     Else
50340      If Options.DeviceWidthPoints >= 1 Then
50350       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50360      End If
50370      If Options.DeviceHeightPoints >= 1 Then
50380       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50390      End If
50400    End If
50410   End If
50420   AddParams "-r" & Options.RAWResolution & "x" & Options.RAWResolution
50430  End If
50440
50450  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50460   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50470  End If
50480  AddParams "-sOutputFile=" & GSOutputFile
50490
50500  AddAdditionalGhostscriptParameters
50510
50520  Dim AdditionalFiles As Collection
50530  Set AdditionalFiles = New Collection
50540  AdditionalFiles.Add PDFDocInfoFile
50550  AdditionalFiles.Add StampFile
50560
50570  AddInputFiles InfoSpoolFileName, AdditionalFiles
50580
50590  ShowParams
50600  CallGhostscript "RAW"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateRAW")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Function CreateSVG(InfoSpoolFileName As String, ByVal GSOutputFile As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String
50020
50030  GSInit Options
50040  InitParams
50050  Set ParamCommands = New Collection
50060
50070  If Options.OneFilePerPage = 1 Then
50080   GSOutputFile = GetOneFilePerPageGSOutPutFileName(GSOutputFile, Options)
50090  End If
50100
50110  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50120
50130  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50140   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50150  End If
50160  AddParams "-I" & tStr
50170  AddParams "-q"
50180  AddParams "-dNOPAUSE"
50190  AddParams "-dBATCH"
50200  AddParams "-q"
50210  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50220   AddParams "-sFONTPATH=" & GetFontsDirectory
50230  End If
50240
50250  AddParams "-sDEVICE=svg"
50260  If Options.DontUseDocumentSettings = 0 Then
50270   If Options.UseFixPapersize <> 0 Then
50280    If Options.UseCustomPaperSize = 0 Then
50290      If LenB(Trim$(Options.Papersize)) > 0 Then
50300       AddParams "-sPAPERSIZE=" & LCase$(Trim$(Options.Papersize))
50310       AddParams "-dFIXEDMEDIA"
50320       AddParams "-dNORANGEPAGESIZE"
50330      End If
50340     Else
50350      If Options.DeviceWidthPoints >= 1 Then
50360       AddParams "-dDEVICEWIDTHPOINTS=" & Options.DeviceWidthPoints
50370      End If
50380      If Options.DeviceHeightPoints >= 1 Then
50390       AddParams "-dDEVICEHEIGHTPOINTS=" & Options.DeviceHeightPoints
50400      End If
50410    End If
50420   End If
50430   AddParams "-r" & Options.SVGResolution & "x" & Options.SVGResolution
50440  End If
50450
50460  If Options.AllowSpecialGSCharsInFilenames = 1 And Options.OneFilePerPage <> 1 Then
50470   GSOutputFile = Replace$(GSOutputFile, "%", "%%")
50480  End If
50490  AddParams "-sOutputFile=" & GSOutputFile
50500
50510  AddAdditionalGhostscriptParameters
50520
50530  Dim AdditionalFiles As Collection
50540  Set AdditionalFiles = New Collection
50550  AdditionalFiles.Add PDFDocInfoFile
50560  AdditionalFiles.Add StampFile
50570
50580  AddInputFiles InfoSpoolFileName, AdditionalFiles
50590
50600  ShowParams
50610  CallGhostscript "SVG"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateSVG")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function CallGScript(GSInfoSpoolFile As String, GSOutputFile As String, _
 Options As tOptions, Ghostscriptdevice As tGhostscriptDevice, PDFDocInfoFile As String, StampFile As String, PDFDocViewFile As String, Optional PDFAFormat As tPDFAFormat = PDFA2b)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim enc As Boolean, encPDF As EncryptData, retEnc As Boolean, Tempfile As String, tL As Long, m As Object, _
  Ghostscript As clsGhostscript
50030
50040  GSInit Options
50050
50061  Select Case Ghostscriptdevice
        Case 0: 'PDF
50080    With Options
50090     If .PDFOptimize = 1 And .PDFUseSecurity = 0 Then
50100       Set Ghostscript = GetGhostscriptVersion
50110       If ((Ghostscript.VersionMajor < 9) Or (Ghostscript.VersionMajor = 9 And Ghostscript.VersionMinor < 7)) Then
50120         Tempfile = GetTempFile(GetTempPathApi, "~CP")
50130         KillFile Tempfile
50140         CreatePDF GSInfoSpoolFile, Tempfile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
50150         OptimizePDF Tempfile, GSOutputFile
50160         KillFile Tempfile
50170        Else
50180         CreatePDF GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
50190       End If
50200      Else
50210       If .PDFUseSecurity <> 0 And SecurityIsPossible = True Then
50220         If pdfforgeDllInstalled And .PDFAes128Encryption = 1 Then
50230           enc = SetEncryptionParams(encPDF, GSInfoSpoolFile, GSOutputFile)
50240           If enc = True Then
50250             Tempfile = GetTempFile(GetTempPathApi, "~CP")
50260             KillFile Tempfile
50270             currentOwnerPassword = encPDF.OwnerPass
50280             currentUserPassword = encPDF.UserPass
50290             CreatePDF GSInfoSpoolFile, Tempfile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
50300             encPDF.InputFile = Tempfile
50310             retEnc = EncryptPDFUsingPdfforgeDll(encPDF)
50320             If retEnc = False Then
50330              IfLoggingWriteLogfile "Error with encryption - using unencrypted file"
50340              KillFile GSOutputFile
50350              If FileExists(GSOutputFile) = False Then
50360               Name Tempfile As GSOutputFile
50370              End If
50380             End If
50390            Else
50400             If Options.UseAutosave = 0 Then
50410              MsgBox LanguageStrings.MessagesMsg23, vbCritical
50420             End If
50430             CreatePDF GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
50440           End If
50450          Else
50460           tL = .PDFOptimize
50470           .PDFOptimize = 0
50480           CreatePDF GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
50490           .PDFOptimize = tL
50500         End If
50510        Else
50520         CreatePDF GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
50530       End If
50540     End If
50550     If pdfforgeDllInstalled Then
50560      If .PDFUpdateMetadata > 0 Then
50570       If .PDFUpdateMetadata = 2 Or _
       (.PDFUpdateMetadata = 1 And (InStr(1, .AdditionalGhostscriptParameters, "dpdfa", vbTextCompare) > 0)) Then
50590        Set m = CreateObject("pdfForge.pdf.pdf")
50600        Tempfile = GetTempFile(GetTempPathApi, "~MP")
50610        KillFile Tempfile
50620        Call m.UpdateXMPMetadata(GSOutputFile, Tempfile)
50630        If FileExists(Tempfile) Then
50640         If KillFile(GSOutputFile) Then
50650          Name Tempfile As GSOutputFile
50660         End If
50670        End If
50680       End If
50690      End If
50700     End If
50710     If DotNet20Installed And pdfforgeDllInstalled Then
50720      If .PDFSigningSignPDF = 1 Then
50730       SignPDF GSOutputFile, currentOwnerPassword, currentUserPassword
50740      End If
50750     End If
50760    End With
50770   Case 1: 'PNG
50780    CreatePNG GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50790   Case 2: 'JPEG
50800    CreateJPEG GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50810   Case 3: 'BMP
50820    CreateBMP GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50830   Case 4: 'PCX
50840    CreatePCX GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50850   Case 5: 'TIFF
50860    CreateTIFF GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50870   Case 6: 'PS
50880    CreatePS GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50890   Case 7: 'EPS
50900    CreateEPS GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50910   Case 8: 'TXT
50920    CreateTXT GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
50930    CreateTextFile GSOutputFile, GS_OutStr
50940   Case 9: 'PDFA
50950    CreatePDFA GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile, PDFAFormat
50960    With Options
50970     If DotNet20Installed And pdfforgeDllInstalled Then
50980      If .PDFUpdateMetadata > 0 Then
50990       Set m = CreateObject("pdfForge.pdf.pdf")
51000       Tempfile = GetTempFile(GetTempPathApi, "~MP")
51010       KillFile Tempfile
51020       Call m.UpdateXMPMetadata(GSOutputFile, Tempfile)
51030       If FileExists(Tempfile) Then
51040        If KillFile(GSOutputFile) Then
51050         Name Tempfile As GSOutputFile
51060        End If
51070       End If
51080      End If
51090      If .PDFSigningSignPDF = 1 Then
51100       SignPDF GSOutputFile
51110      End If
51120     End If
51130    End With
51140   Case 10: 'PDFX
51150    CreatePDFX GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile, PDFDocViewFile
51160    With Options
51170     If DotNet20Installed And pdfforgeDllInstalled Then
51180      If .PDFSigningSignPDF = 1 Then
51190       SignPDF GSOutputFile
51200      End If
51210     End If
51220    End With
51230   Case 11: 'PSD
51240    CreatePSD GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
51250   Case 12: 'PCL
51260    CreatePCL GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
51270   Case 13: 'RAW
51280    CreateRAW GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
51290   Case 14: 'SVG
51300    CreateSVG GSInfoSpoolFile, GSOutputFile, Options, PDFDocInfoFile, StampFile
51310  End Select
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CallGScript")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Sub SignPDF(filename As String, Optional ownerPasswd As String = "", Optional userPasswd As String = "")
 Dim pdf As Object, pxs As Object
 Dim res As Long, files As Collection, Tempfile As String

 Set pxs = CreateObject("pdfforge.PDF.PDF.X509.Signing")

 With Options
  If LenB(.PDFSigningPFXFile) = 0 Then
    res = OpenFileDialog(files, "", _
     LanguageStrings.OptionsPDFSigningPfxP12Files & " (*.pfx,*.p12)|*.pfx;*.p12|" & _
     LanguageStrings.OptionsPDFSigningPfxFiles & " (*.pfx)|*pfx|" & _
     LanguageStrings.OptionsPDFSigningP12Files & " (*.p12|*.p12", _
     "*.pfx;*.p12", GetMyFiles, LanguageStrings.OptionsPDFSigningChooseCertifcateFile, _
     OFN_FILEMUSTEXIST Or OFN_EXPLORER Or OFN_LONGNAMES Or OFN_PATHMUSTEXIST, 0, 1)
    If res > 0 Then
     pxs.certficateFilename = files(1)
    End If
   Else
    pxs.certficateFilename = .PDFSigningPFXFile
  End If
  If LenB(.PDFSigningPFXFilePassword) > 0 Then
    PFXPassword = .PDFSigningPFXFilePassword
   Else
    'Ask for the password
    frmCertificatePassword.certFilename = pxs.certficateFilename
    frmCertificatePassword.Show vbModal
  End If
  If LenB(PFXPassword) = 0 Then
   MsgBox LanguageStrings.OptionsPDFSigningCertificateEmptyPassword, vbCritical + vbOKOnly
   Exit Sub
  End If
  pxs.certifcatePassword = PFXPassword
  Tempfile = GetTempFile(GetTempPathApi, "~MP")
  KillFile Tempfile
  If .PDFSigningSignatureVisible = 0 Then
    pxs.signatureVisible = False
   Else
    pxs.signatureVisible = True
  End If
  If .PDFSigningMultiSignature = 0 Then
    pxs.multiSignatures = False
   Else
    pxs.multiSignatures = True
  End If
  If ownerPasswd = vbNullString Then
   ownerPasswd = ""
  End If
  If userPasswd = vbNullString Then
   userPasswd = ""
  End If

  Set pdf = CreateObject("pdfforge.PDF.PDF")
  If pdf.IsEncrypted(filename) Then
    Set pxs.PDFEncryptor = CreateObject("pdfforge.pdf.PDFEncryptor")
    res = pdf.GetEncryptionSettings(filename, ownerPasswd, pxs.PDFEncryptor)
    pxs.PDFEncryptor.OwnerPassword = ownerPasswd
    pxs.PDFEncryptor.UserPassword = userPasswd
   Else
    Set pxs.PDFEncryptor = Nothing
  End If
  pxs.SignatureContact = .PDFSigningSignatureContact
  pxs.SignatureLocation = .PDFSigningSignatureLocation
  pxs.SignatureOnPage = .PDFSigningSignatureOnPage
  pxs.SignaturePositionLowerLeftX = .PDFSigningSignatureLeftX
  pxs.SignaturePositionLowerLeftY = .PDFSigningSignatureLeftY
  pxs.SignaturePositionUpperRightX = .PDFSigningSignatureRightX
  pxs.SignaturePositionUpperRightY = .PDFSigningSignatureRightY
  pxs.SignatureReason = .PDFSigningSignatureReason
  pxs.TimeServerURL = .PDFSigningTimeServerUrl
  pxs.HashAlgorithm = "SHA512" ' MD2, MD5, SHA1, SHA256, SHA384, SHA512, RIPEMD160

  On Error Resume Next
  Call pxs.SignPDFFile_2(filename, ownerPasswd, Tempfile)
  If Err.Number <> 0 Then
    MsgBox LanguageStrings.MessagesMsg45 & vbCrLf & vbCrLf & Err.Number & ": " & Err.Description, vbExclamation
    Err.Clear
    On Error GoTo 0
    If FileExists(Tempfile) Then
     KillFile Tempfile
    End If
   Else
    If FileExists(Tempfile) Then
     If KillFile(filename) Then
      Name Tempfile As filename
     End If
    End If
  End If
 End With
End Sub

Public Function OptimizePDF(PDFInputFilename As String, PDFOutputFilename As String) As Boolean
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim LastStop As Currency, tStr As String, c As Currency
50020  InitParams
50030
50040  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50050
50060  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50070   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50080  End If
50090  AddParams "-I" & tStr
50100  AddParams "-q"
50110  AddParams "-dNODISPLAY"
50120  'AddParams "-dSAFER"
50130  AddParams "-dDELAYSAFER"
50140  AddParams "--"
50150  AddParams "pdfopt.ps"
50160  AddParams PDFInputFilename
50170  AddParams PDFOutputFilename
50180
50190  GSParams(0) = "pdfopt"
50200  If PerformanceTimer Then
50210    c = ExactTimer_Value() - LastStop
50220    IfLoggingWriteLogfile "Time for converting: " & _
    Format$(Int(c) * (1 / 86400), "hh:nn:ss:") & Format$(((c) - Int(c)) * 1000, "000")
50240   Else
50250    IfLoggingWriteLogfile "Time for converting -> No performance timer"
50260  End If
50270
50280  If PerformanceTimer Then
50290   LastStop = ExactTimer_Value()
50300  End If
50310  ShowParams
50320  OptimizePDF = CallGS(GSParams)
50330  If PerformanceTimer Then
50340    c = ExactTimer_Value() - LastStop
50350    IfLoggingWriteLogfile "Time for optimizing: " & _
    Format$(Int(c) * (1 / 86400), "hh:nn:ss:") & Format$(((c) - Int(c)) * 1000, "000")
50370   Else
50380    IfLoggingWriteLogfile "Time for optimizing: No performance timer"
50390  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "OptimizePDF")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function Bool2Text(Number As Long)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  If Number = 1 Then
50020   Bool2Text = "true"
50030  Else
50040   Bool2Text = "false"
50050  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "Bool2Text")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Sub SelectColorCompression(ByVal gsMethod)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  GS_COMPRESSCOLORAUTO = "false"
50021  Select Case gsMethod
        Case 0
50040    GS_COMPRESSCOLORAUTO = "true"
50050    GS_COMPRESSCOLORMETHOD = "null"
50060    GS_COMPRESSCOLORLEVEL = "null"
50070   Case 1
50080    GS_COMPRESSCOLORMETHOD = "DCTEncode"
50090    GS_COMPRESSCOLORLEVEL = "Maximum"
50100   Case 2
50110    GS_COMPRESSCOLORMETHOD = "DCTEncode"
50120    GS_COMPRESSCOLORLEVEL = "High"
50130   Case 3
50140    GS_COMPRESSCOLORMETHOD = "DCTEncode"
50150    GS_COMPRESSCOLORLEVEL = "Medium"
50160   Case 4
50170    GS_COMPRESSCOLORMETHOD = "DCTEncode"
50180    GS_COMPRESSCOLORLEVEL = "Low"
50190   Case 5
50200    GS_COMPRESSCOLORMETHOD = "DCTEncode"
50210    GS_COMPRESSCOLORLEVEL = "Minimum"
50220   Case 6
50230    GS_COMPRESSCOLORMETHOD = "FlateEncode"
50240    GS_COMPRESSCOLORLEVEL = "Maximum"
50250  End Select
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SelectColorCompression")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub SelectGreyCompression(ByVal gsMethod)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  GS_COMPRESSGREYAUTO = "false"
50021  Select Case gsMethod
        Case 0
50040    GS_COMPRESSGREYAUTO = "true"
50050    GS_COMPRESSGREYMETHOD = "null"
50060    GS_COMPRESSGREYLEVEL = "null"
50070   Case 1
50080    GS_COMPRESSGREYMETHOD = "DCTEncode"
50090    GS_COMPRESSGREYLEVEL = "Maximum"
50100   Case 2
50110    GS_COMPRESSGREYMETHOD = "DCTEncode"
50120    GS_COMPRESSGREYLEVEL = "High"
50130   Case 3
50140    GS_COMPRESSGREYMETHOD = "DCTEncode"
50150    GS_COMPRESSGREYLEVEL = "Medium"
50160   Case 4
50170    GS_COMPRESSGREYMETHOD = "DCTEncode"
50180    GS_COMPRESSGREYLEVEL = "Low"
50190   Case 5
50200    GS_COMPRESSGREYMETHOD = "DCTEncode"
50210    GS_COMPRESSGREYLEVEL = "Minimum"
50220   Case 6
50230    GS_COMPRESSGREYMETHOD = "FlateEncode"
50240    GS_COMPRESSGREYLEVEL = "Maximum"
50250  End Select
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SelectGreyCompression")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub SelectMonoCompression(ByVal gsMethod)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50011  Select Case gsMethod
        Case 0
50030    GS_COMPRESSMONOMETHOD = "CCITTFaxEncode"
50040   Case 1
50050    GS_COMPRESSMONOMETHOD = "FlateEncode"
50060   Case 2
50070    GS_COMPRESSMONOMETHOD = "RunLengthEncode"
50080   Case 3
50090    GS_COMPRESSMONOMETHOD = "LZWEncode"
50100  End Select
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SelectMonoCompression")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub InitParams()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  GSParamsIndex = 0
50020  ReDim GSParams(GSParamsIndex)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "InitParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub ShowParams()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim i As Long, tStr As String
50020  If Logging Then
50030   tStr = GSParams(LBound(GSParams))
50040   For i = LBound(GSParams) + 1 To UBound(GSParams)
50050    tStr = tStr & vbCrLf & GSParams(i)
50060   Next i
50070   IfLoggingWriteLogfile "Ghostscriptparameter:" & vbCrLf & tStr
50080  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "ShowParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub AddParams(strValue As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  GSParamsIndex = GSParamsIndex + 1
50020  ReDim Preserve GSParams(GSParamsIndex)
50030  GSParams(GSParamsIndex) = strValue
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "AddParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Function BuildPermissionString(encData As EncryptData) As String
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim strPermissions As String
50020
50030  strPermissions = vbNullString
50040  strPermissions = strPermissions & Abs(Int(Not encData.DisallowPrinting))
50050  strPermissions = strPermissions & Abs(Int(Not encData.DisallowModifyContents))
50060  strPermissions = strPermissions & Abs(Int(Not encData.DisallowCopy))
50070  strPermissions = strPermissions & Abs(Int(Not encData.DisallowModifyAnnotations))
50080  If Options.PDFHighEncryption Then
50090    strPermissions = strPermissions & Abs(Int(encData.AllowFillIn)) '(128 bit only)
50100    strPermissions = strPermissions & Abs(Int(encData.AllowScreenReaders)) '(128 bit only)
50110    strPermissions = strPermissions & Abs(Int(encData.AllowAssembly)) '(128 bit only)
50120    strPermissions = strPermissions & Abs(Int(encData.AllowDegradedPrinting)) '(128 bit only)
50130   Else
50140    strPermissions = strPermissions & "0000"
50150  End If
50160  BuildPermissionString = strPermissions
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "BuildPermissionString")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function EncryptPDF(encData As EncryptData) As Boolean
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim strPermissions As String, strShell As String, ret As Double
50020
50030  strPermissions = BuildPermissionString(encData)
50040
50050 ' strShell = App.Path & "\pdfencrypt.exe """ & encData.InputFile & """ """ & encData.OutputFile & """ User=" & encData.UserPass & " Owner=" & encData.OwnerPass & " " & strPermissions & " " & encData.EncryptionLevel
50060 ' strShell = CompletePath(Options.DirectoryJava) & "Java.exe -cp """ & CompletePath(App.Path) & "iText.jar"" com.lowagie.tools.encrypt_pdf """ & encData.InputFile & """ """ & encData.OutputFile & """ """ & encData.UserPass & """ """ & encData.OwnerPass & """ " & strPermissions & " " & encData.EncryptionLevel
50070
50080  strShell = PDFCreatorApplicationPath & "pdfenc.exe """ & encData.InputFile & """ """ & encData.OutputFile & """ """ & encData.UserPass & """ """ & encData.OwnerPass & """ " & strPermissions & " " & encData.EncryptionLevel
50090
50100  IfLoggingWriteLogfile strShell
50110
50120  ret = RunProgramWait(strShell, False)
50130
50140  If Dir$(encData.OutputFile) <> vbNullString Then
50150   EncryptPDF = True
50160  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "EncryptPDF")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function EncryptPDFUsingPdfforgeDllTest() As Boolean
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim pdf As Object, enc As Object
50020  Set enc = CreateObject("pdfForge.pdf.PDFEncryptor")
50030
50040  enc.AllowAssembly = False
50050  enc.AllowCopy = False
50060  enc.AllowFillIn = False
50070  enc.AllowModifyAnnotations = False
50080  enc.AllowModifyContents = False
50090  enc.AllowPrinting = True
50100  enc.AllowPrintingHighResolution = False
50110  enc.AllowScreenReaders = True
50120  enc.EncryptionMethode = 2
50130  enc.OwnerPassword = "pdfforge"
50140  enc.UserPassword = ""
50150  Set pdf = CreateObject("pdfForge.pdf.pdf")
50160  pdf.CreatePDFTestDocument "test.pdf", 10, "This is an example.", True
50170  pdf.EncryptPDFFile "test.pdf", "encrypted.pdf", enc
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "EncryptPDFUsingPdfforgeDllTest")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function EncryptPDFUsingPdfforgeDll(encData As EncryptData) As Boolean
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim m As Object, enc As Object, res As Long
50020  Set m = CreateObject("pdfforge.pdf.pdf")
50030  Set enc = CreateObject("pdfforge.pdf.PDFEncryptor")
50040
50050  enc.AllowAssembly = encData.AllowAssembly
50060  enc.AllowCopy = Not encData.DisallowCopy
50070  enc.AllowFillIn = encData.AllowFillIn
50080  enc.AllowModifyAnnotations = Not encData.DisallowModifyAnnotations
50090  enc.AllowModifyContents = Not encData.DisallowModifyContents
50100  enc.AllowPrinting = Not encData.DisallowPrinting
50110  enc.AllowPrintingHighResolution = Not encData.AllowDegradedPrinting
50120  enc.AllowScreenReaders = encData.AllowFillIn
50130  enc.EncryptionMethod = 2
50140  enc.OwnerPassword = encData.OwnerPass
50150  enc.UserPassword = encData.UserPass
50160
50170  res = m.EncryptPDFFile(encData.InputFile, encData.OutputFile, enc)
50180  If res = 0 Then
50190   EncryptPDFUsingPdfforgeDll = True
50200  Else
50210   EncryptPDFUsingPdfforgeDll = False
50220  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "EncryptPDFUsingPdfforgeDll")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function CalculatePermissions(ByRef encData As EncryptData) As Long
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tB As Long, tB2 As Long
50020  tB = 192
50030  With encData
50040   If Abs(.DisallowPrinting) = 0 Then
50050    tB = tB + 4
50060   End If
50070   If Abs(.DisallowModifyContents) = 0 Then
50080    tB = tB + 8
50090   End If
50100   If Abs(.DisallowCopy) = 0 Then
50110    tB = tB + 16
50120   End If
50130   If Abs(.DisallowModifyAnnotations) = 0 Then
50140    tB = tB + 32
50150   End If
50160   CalculatePermissions = tB - 256
50170   If .EncryptionLevel = encStrong Then
50180     tB2 = 240
50190     If Abs(.AllowFillIn) <> 0 Then
50200      tB2 = tB2 + 1
50210     End If
50220     If Abs(.AllowScreenReaders) <> 0 Then
50230      tB2 = tB2 + 2
50240     End If
50250     If Abs(.AllowAssembly) <> 0 Then
50260      tB2 = tB2 + 4
50270     End If
50280     If Abs(.AllowDegradedPrinting) = 0 Then
50290      tB2 = tB2 + 8
50300     End If
50310    CalculatePermissions = CalculatePermissions - (255 - tB2) * 256&
50320   End If
50330  End With
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CalculatePermissions")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function SetEncryptionParams(ByRef encData As EncryptData, InputFile As String, OutputFile As String) As Boolean
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim retPasswd As Boolean
50020
50030  encData.InputFile = InputFile
50040  encData.OutputFile = OutputFile
50050
50060  If Len(Options.PDFOwnerPasswordString) > 0 Then
50070    encData.OwnerPass = Options.PDFOwnerPasswordString
50080    OwnerPassword = Options.PDFOwnerPasswordString
50090    If Options.PDFUserPass = 1 Then
50100     encData.UserPass = Options.PDFUserPasswordString
50110     UserPassword = Options.PDFUserPasswordString
50120    End If
50130    retPasswd = True
50140   Else
50150    If SavePasswordsForThisSession = False Then
50160      If Options.UseAutosave = 0 Then
50170        retPasswd = EnterPasswords(encData.UserPass, encData.OwnerPass, frmPassword)
50180       Else
50190        retPasswd = False
50200      End If
50210     Else
50220      encData.OwnerPass = OwnerPassword: encData.UserPass = UserPassword
50230    End If
50240  End If
50250  If retPasswd = True Or SavePasswordsForThisSession = True Then
50260    With encData
50270     .DisallowPrinting = Options.PDFDisallowPrinting
50280     .DisallowModifyContents = Options.PDFDisallowModifyContents
50290     .DisallowCopy = Options.PDFDisallowCopy
50300     .DisallowModifyAnnotations = Options.PDFDisallowModifyAnnotations
50310     .AllowFillIn = Options.PDFAllowFillIn
50320     .AllowScreenReaders = Options.PDFAllowScreenReaders
50330     .AllowAssembly = Options.PDFAllowAssembly
50340     .AllowDegradedPrinting = Options.PDFAllowDegradedPrinting
50350     If Options.PDFHighEncryption = 1 Then
50360       .EncryptionLevel = encStrong
50370      Else
50380       .EncryptionLevel = encLow
50390     End If
50400    End With
50410    SetEncryptionParams = True
50420    encData.UserPass = UserPassword
50430    encData.OwnerPass = OwnerPassword
50440   Else
50450    SetEncryptionParams = False
50460  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SetEncryptionParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Sub SetColorParams()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  If Options.PDFCompressionColorCompression = 1 Then
50020    AddParams "-dEncodeColorImages=true"
50030    If Options.PDFCompressionColorCompressionChoice = 0 Then
50040      AddParams "-dAutoFilterColorImages=true"
50050     Else
50060      AddParams "-dAutoFilterColorImages=false"
50070      If Options.PDFCompressionColorResample = 1 Then
50080        AddParams "-dDownsampleColorImages=true"
50091        Select Case Options.PDFCompressionColorResampleChoice
              Case 0:
50110          AddParams "-dColorImageDownsampleType=/Subsample"
50120         Case 1:
50130          AddParams "-dColorImageDownsampleType=/Average"
50140         Case 2:
50150          AddParams "-dColorImageDownsampleType=/Bicubic"
50160        End Select
50170        AddParams "-dColorImageResolution=" & Options.PDFCompressionColorResolution
50180       Else
50190        AddParams "-dDownsampleColorImages=false"
50200      End If
50211      Select Case Options.PDFCompressionColorCompressionChoice
            Case 1:
50230        AddParams "-dColorImageFilter=/DCTEncode"
50240        AddParamCommand ".setpdfwrite << /ColorImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionColorCompressionJPEGMaximumFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50270       Case 2:
50280        AddParams "-dColorImageFilter=/DCTEncode"
50290        AddParamCommand ".setpdfwrite << /ColorImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionColorCompressionJPEGHighFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50320       Case 3:
50330        AddParams "-dColorImageFilter=/DCTEncode"
50340        AddParamCommand ".setpdfwrite << /ColorImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionColorCompressionJPEGMediumFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50370       Case 4:
50380        AddParams "-dColorImageFilter=/DCTEncode"
50390        AddParamCommand ".setpdfwrite << /ColorImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionColorCompressionJPEGLowFactor), GetDecimalChar, ".") & _
        " /Blend 0 /HSample [1 1 1 1] /VSample [1 1 1 1]>> >> setdistillerparams"
50420       Case 5:
50430        AddParams "-dColorImageFilter=/DCTEncode"
50440        AddParamCommand ".setpdfwrite << /ColorImageDict <</QFactor " & _
       Replace$(CStr(Options.PDFCompressionColorCompressionJPEGMinimumFactor), GetDecimalChar, ".") & _
       " /Blend 0 /HSample [1 1 1 1] /VSample [1 1 1 1]>> >> setdistillerparams"
50470       Case 6:
50480        AddParams "-dColorImageFilter=/DCTEncode"
50490        AddParamCommand ".setpdfwrite << /ColorImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionColorCompressionJPEGManualFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50520       Case 7:
50530        AddParams "-dColorImageFilter=/FlateEncode"
50540       Case 8:
50550        AddParams "-dColorImageFilter=/LZWEncode"
50560      End Select
50570    End If
50580   Else
50590    AddParams "-dEncodeColorImages=false"
50600  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SetColorParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub SetGreyParams()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  If Options.PDFCompressionGreyCompression = 1 Then
50020    AddParams "-dEncodeGrayImages=true"
50030    If Options.PDFCompressionGreyCompressionChoice = 0 Then
50040      AddParams "-dAutoFilterGrayImages=true"
50050     Else
50060      AddParams "-dAutoFilterGrayImages=false"
50070      If Options.PDFCompressionGreyResample = 1 Then
50080        AddParams "-dDownsampleGrayImages=true"
50091        Select Case Options.PDFCompressionGreyResampleChoice
              Case 0:
50110          AddParams "-dGrayImageDownsampleType=/Subsample"
50120         Case 1:
50130          AddParams "-dGrayImageDownsampleType=/Average"
50140         Case 2:
50150          AddParams "-dGrayImageDownsampleType=/Bicubic"
50160        End Select
50170        AddParams "-dGrayImageResolution=" & Options.PDFCompressionGreyResolution
50180       Else
50190        AddParams "-dDownsampleGrayImages=false"
50200      End If
50211      Select Case Options.PDFCompressionGreyCompressionChoice
            Case 1:
50230        AddParams "-dGrayImageFilter=/DCTEncode"
50240        AddParamCommand ".setpdfwrite << /GrayImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionGreyCompressionJPEGMaximumFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50270       Case 2:
50280        AddParams "-dGrayImageFilter=/DCTEncode"
50290        AddParamCommand ".setpdfwrite << /GrayImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionGreyCompressionJPEGHighFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50320       Case 3:
50330        AddParams "-dGrayImageFilter=/DCTEncode"
50340        AddParamCommand ".setpdfwrite << /GrayImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionGreyCompressionJPEGMediumFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50370       Case 4:
50380        AddParams "-dGrayImageFilter=/DCTEncode"
50390        AddParamCommand ".setpdfwrite << /GrayImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionGreyCompressionJPEGLowFactor), GetDecimalChar, ".") & _
        " /Blend 0 /HSample [1 1 1 1] /VSample [1 1 1 1]>> >> setdistillerparams"
50420       Case 5:
50430        AddParams "-dGrayImageFilter=/DCTEncode"
50440        AddParamCommand ".setpdfwrite << /GrayImageDict <</QFactor " & _
       Replace$(CStr(Options.PDFCompressionGreyCompressionJPEGMinimumFactor), GetDecimalChar, ".") & _
       " /Blend 0 /HSample [1 1 1 1] /VSample [1 1 1 1]>> >> setdistillerparams"
50470       Case 6:
50480        AddParams "-dGrayImageFilter=/DCTEncode"
50490        AddParamCommand ".setpdfwrite << /GrayImageDict <</QFactor " & _
        Replace$(CStr(Options.PDFCompressionGreyCompressionJPEGManualFactor), GetDecimalChar, ".") & _
        " /Blend 1 /HSample [2 1 1 2] /VSample [2 1 1 2]>> >> setdistillerparams"
50520       Case 7:
50530        AddParams "-dGrayImageFilter=/FlateEncode"
50540       Case 8:
50550        AddParams "-dGrayImageFilter=/LZWEncode"
50560      End Select
50570    End If
50580   Else
50590    AddParams "-dEncodeGrayImages=false"
50600  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SetGreyParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub SetMonoParams()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  If Options.PDFCompressionMonoCompression = 1 Then
50020    AddParams "-dEncodeMonoImages=true"
50031    Select Case Options.PDFCompressionMonoCompressionChoice
          Case 0:
50050      AddParams "-dMonoImageFilter=/CCITTFaxEncode"
50060     Case 1:
50070      AddParams "-dMonoImageFilter=/FlateEncode"
50080     Case 2:
50090      AddParams "-dMonoImageFilter=/RunLengthEncode"
50100     Case 3:
50110      AddParams "-dMonoImageFilter=/LZWEncode"
50120    End Select
50130    If Options.PDFCompressionMonoResample = 1 Then
50140      AddParams "-dDownsampleMonoImages=true"
50151      Select Case Options.PDFCompressionMonoResampleChoice
            Case 0:
50170        AddParams "-dMonoImageDownsampleType=/Subsample"
50180       Case 1:
50190        AddParams "-dMonoImageDownsampleType=/Average"
50200       Case 2:
50210        AddParams "-dMonoImageDownsampleType=/Bicubic"
50220      End Select
50230      AddParams "-dMonoImageResolution=" & Options.PDFCompressionMonoResolution
50240     Else
50250      AddParams "-dDownsampleMonoImages=false"
50260    End If
50270   Else
50280    AddParams "-dEncodeMonoImages=false"
50290  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "SetMonoParams")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Public Function GhostScriptSecurity() As Boolean
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  GhostScriptSecurity = False
50020  If LenB(CompletePath(Options.DirectoryGhostscriptBinaries) & GsDll) = 0 Then
50030   Exit Function
50040  End If
50050 ' GsDllLoaded = LoadDLL(CompletePath(Options.DirectoryGhostscriptBinaries) & GsDll)
50060  If GsDllLoaded = 0 Then
50070   Exit Function
50080  End If
50090  GSRevision = GetGhostscriptRevision
50100 ' UnLoadDLL GsDllLoaded
50110  If InStr(UCase$(GSRevision.strProduct), "AFPL") > 0 Then
50120   If GSRevision.intRevision < 814 Then
50130    Exit Function
50140   End If
50150   GhostScriptSecurity = True
50160   Exit Function
50170  End If
50180  If InStr(UCase$(GSRevision.strProduct), "GPL") > 0 Then
50190   If GSRevision.intRevision < 815 Then
50200    Exit Function
50210   End If
50220   GhostScriptSecurity = True
50230   Exit Function
50240  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "GhostScriptSecurity")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function GetGhostscriptversionFromString(GhostscriptVersionStr As String) As clsGhostscript
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim Ghostscript As clsGhostscript, tStr As String, pos As Long
50020  Set Ghostscript = New clsGhostscript
50030  If Len(GhostscriptVersionStr) > 0 Then
50040   pos = InStr(1, GhostscriptVersionStr, ".", vbTextCompare)
50050   If pos > 1 Then
50060     tStr = Mid(GhostscriptVersionStr, 1, pos - 1)
50070     If IsNumeric(tStr) Then
50080      Ghostscript.VersionMajor = CLng(tStr)
50090     End If
50100     tStr = Mid(GhostscriptVersionStr, pos + 1)
50110     If IsNumeric(tStr) Then
50120      Ghostscript.VersionMinor = CLng(tStr)
50130     End If
50140    Else
50150     If IsNumeric(GhostscriptVersionStr) Then
50160      Ghostscript.VersionMajor = CLng(GhostscriptVersionStr)
50170     End If
50180   End If
50190  End If
50200  Set GetGhostscriptversionFromString = Ghostscript
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "GetGhostscriptversionFromString")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function GetAllGhostscriptversions() As Collection
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim reg As clsRegistry, tStr As String, tColl As Collection, i As Long, GS_DLL As String, GS_LIB As String
50020  Dim Ghostscript As clsGhostscript, regGhostscriptVersion As String
50030
50040  Set reg = New clsRegistry
50050  Set GetAllGhostscriptversions = New Collection
50060  With reg
50070   .hkey = HKEY_LOCAL_MACHINE
50080   .KeyRoot = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & Uninstall_GUID
50090   If .KeyExists = True Then
50100    tStr = Trim$(.GetRegistryValue("GhostscriptCopyright"))
50110    If LenB(tStr) > 0 Then
50120     Set Ghostscript = New clsGhostscript
50130     regGhostscriptVersion = .GetRegistryValue("GhostscriptVersion")
50140     tStr = Replace$(LanguageStrings.OptionsGhostscriptInternal, "%1", tStr)
50150     tStr = Replace$(tStr, "%2", Trim$(.GetRegistryValue("GhostscriptVersion")))
50160     Set Ghostscript = GetGhostscriptversionFromString(regGhostscriptVersion)
50170     Ghostscript.Description = tStr
50180     Ghostscript.VersionInternal = True
50190     GetAllGhostscriptversions.Add Ghostscript
50200    End If
50210   End If
50220   tStr = "AFPL Ghostscript"
50230   .KeyRoot = "SOFTWARE\" & tStr
50240   Set tColl = .EnumRegistryKeys(HKEY_LOCAL_MACHINE, .KeyRoot)
50250   For i = 1 To tColl.Count
50260    .SubKey = tColl.Item(i)
50270    GS_DLL = .GetRegistryValue("GS_DLL")
50280    GS_LIB = .GetRegistryValue("GS_LIB")
50290    If Len(GS_DLL) > 0 Then
50300     If FileExists(GS_DLL) = True Then
50310      Set Ghostscript = GetGhostscriptversionFromString(tColl.Item(i))
50320      Ghostscript.Description = tStr & " " & tColl.Item(i)
50330      GetAllGhostscriptversions.Add Ghostscript
50340     End If
50350    End If
50360   Next i
50370   tStr = "GNU Ghostscript"
50380   .KeyRoot = "SOFTWARE\" & tStr
50390   Set tColl = .EnumRegistryKeys(HKEY_LOCAL_MACHINE, .KeyRoot)
50400   For i = 1 To tColl.Count
50410    .SubKey = tColl.Item(i)
50420    GS_DLL = .GetRegistryValue("GS_DLL")
50430    GS_LIB = .GetRegistryValue("GS_LIB")
50440    If Len(GS_DLL) > 0 Then
50450     If FileExists(GS_DLL) = True Then
50460      Set Ghostscript = GetGhostscriptversionFromString(tColl.Item(i))
50470      Ghostscript.Description = tStr & " " & tColl.Item(i)
50480      GetAllGhostscriptversions.Add Ghostscript
50490     End If
50500    End If
50510   Next i
50520   tStr = "GPL Ghostscript"
50530   .KeyRoot = "SOFTWARE\" & tStr
50540   Set tColl = .EnumRegistryKeys(HKEY_LOCAL_MACHINE, .KeyRoot)
50550   For i = 1 To tColl.Count
50560    .SubKey = tColl.Item(i)
50570    GS_DLL = .GetRegistryValue("GS_DLL")
50580    GS_LIB = .GetRegistryValue("GS_LIB")
50590    If Len(GS_DLL) > 0 Then
50600     If FileExists(GS_DLL) = True Then
50610      Set Ghostscript = GetGhostscriptversionFromString(tColl.Item(i))
50620      Ghostscript.Description = tStr & " " & tColl.Item(i)
50630      GetAllGhostscriptversions.Add Ghostscript
50640     End If
50650    End If
50660   Next i
50670  End With
50680  Set reg = Nothing
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "GetAllGhostscriptversions")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function CreateStampFile(InfoSpoolFileName As String) As String
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim StampPage As String, tStr As String, R As String, G As String, b As String, Path As String, ff As Long, _
  StampFile As String, StampString As String, StampFontsize As Double, StampOutlineFontthickness As Double
50030  Dim File As String
50040  StampString = RemoveLeadingAndTrailingQuotes(Trim$(Options.StampString))
50050  If Len(StampString) > 0 Then
50060   StampPage = StrConv(LoadResData(101, "STAMPPAGE"), vbUnicode)
50070   StampPage = Replace(StampPage, vbCrLf, vbCr, , , vbBinaryCompare)
50080   StampPage = Replace(StampPage, "[STAMPSTRING]", EncodeCharsOctal(StampString), , , vbTextCompare)
50090   StampPage = Replace(StampPage, "[FONTNAME]", Replace(Trim$(Options.StampFontname), " ", ""), , , vbTextCompare)
50100   StampFontsize = 48
50110   If IsNumeric(Options.StampFontsize) = True Then
50120    If CDbl(Options.StampFontsize) > 0 Then
50130     StampFontsize = CDbl(Options.StampFontsize)
50140    End If
50150   End If
50160   StampPage = Replace(StampPage, "[FONTSIZE]", StampFontsize, , , vbTextCompare)
50170   StampOutlineFontthickness = 0
50180   If IsNumeric(Options.StampOutlineFontthickness) = True Then
50190    If CDbl(Options.StampOutlineFontthickness) >= 0 Then
50200     StampOutlineFontthickness = CDbl(Options.StampOutlineFontthickness)
50210    End If
50220   End If
50230   StampPage = Replace(StampPage, "[STAMPOUTLINEFONTTHICKNESS]", StampOutlineFontthickness, , , vbTextCompare)
50240   If Options.StampUseOutlineFont <> 1 Then
50250     StampPage = Replace(StampPage, "[USEOUTLINEFONT]", "show", , , vbTextCompare)
50260    Else
50270     StampPage = Replace(StampPage, "[USEOUTLINEFONT]", "true charpath stroke", , , vbTextCompare)
50280   End If
50290   If Len(Options.StampFontColor) > 0 Then
50300     tStr = Replace$(Options.StampFontColor, "#", "&H")
50310     If IsNumeric(tStr) = True Then
50320       R = Replace$(Format(CDbl((CLng(tStr) And CLng("&HFF0000")) / 65536) / 255#, "0.00"), ",", ".", , 1)
50330       G = Replace$(Format(CDbl((CLng(tStr) And CLng("&H00FF00")) / 256) / 255#, "0.00"), ",", ".", , 1)
50340       b = Replace$(Format(CDbl(CLng(tStr) And CLng("&H0000FF")) / 255#, "0.00"), ",", ".", , 1)
50350       StampPage = Replace(StampPage, "[FONTCOLOR]", R & " " & G & " " & b, , , vbTextCompare)
50360      Else
50370       StampPage = Replace(StampPage, "[FONTCOLOR]", "1 0 0", , , vbTextCompare)
50380     End If
50390    Else
50400     StampPage = Replace(StampPage, "[FONTCOLOR]", "1 0 0", , , vbTextCompare)
50410   End If
50420   SplitPath InfoSpoolFileName, , Path, , File
50430   StampFile = CompletePath(Path) & File & ".stm"
50440   ff = FreeFile
50450   Open StampFile For Output As #ff
50460   Print #ff, StampPage
50470   Close #ff
50480   CreateStampFile = StampFile
50490  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CreateStampFile")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Private Sub AddParamCommands()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim i As Long
50020  If ParamCommands.Count > 0 Then
50030   AddParams "-c"
50040   For i = 1 To ParamCommands.Count
50050    AddParams ParamCommands(i)
50060   Next i
50070  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "AddParamCommands")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub AddParamCommand(GhostscriptCommand As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  ParamCommands.Add GhostscriptCommand
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "AddParamCommand")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub AddAdditionalGhostscriptParameters()
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String, tStrf() As String, i As Long
50020  tStr = Replace$(Trim$(Options.AdditionalGhostscriptParameters), "<app>", PDFCreatorApplicationPath, , , vbTextCompare)
50030  tStr = Replace$(Trim$(tStr), "<gslib>", CompletePath(Options.DirectoryGhostscriptLibraries), , , vbTextCompare)
50040  If LenB(tStr) > 0 Then
50050   If InStr(1, tStr, "|") > 0 Then
50060     tStrf = Split(tStr, "|")
50070     For i = LBound(tStrf) To UBound(tStrf)
50080      tStr = Trim$(tStrf(i))
50090      If LenB(tStr) > 0 Then
50100       AddParams tStr
50110      End If
50120     Next i
50130    Else
50140     AddParams tStr
50150   End If
50160  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "AddAdditionalGhostscriptParameters")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Public Sub CheckForPrintingAfterSaving(InfoSpoolFileName As String, Options As tOptions, PDFDocInfoFile As String, StampFile As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String, PrintAfterSavingBitsPerPixel(2) As String, NoCancelStr As String, sPrinter1 As String, _
  sQueryUser As String, sMaxResolution As String
50030
50040  If Options.PrintAfterSaving = 0 Then
50050   Exit Sub
50060  End If
50070
50080  GSInit Options
50090  InitParams
50100  Set ParamCommands = New Collection
50110
50120  PrintAfterSavingBitsPerPixel(0) = "1": PrintAfterSavingBitsPerPixel(1) = "4"
50130  PrintAfterSavingBitsPerPixel(2) = "24"
50140
50150  tStr = Options.DirectoryGhostscriptLibraries & GetGhostscriptResourceString
50160
50170  If LenB(LTrim(Options.AdditionalGhostscriptSearchpath)) > 0 Then
50180   tStr = tStr & ";" & LTrim(Options.AdditionalGhostscriptSearchpath)
50190  End If
50200  AddParams "-I" & tStr
50210  AddParams "-q"
50220  AddParams "-dNOPAUSE"
50230  AddParams "-dBATCH"
50240  If LenB(GetFontsDirectory) > 0 And Options.AddWindowsFontpath = 1 Then
50250   AddParams "-sFONTPATH=" & GetFontsDirectory
50260  End If
50270
50280  NoCancelStr = "/NoCancel "
50290  If Options.PrintAfterSavingNoCancel = 1 Then
50300    NoCancelStr = NoCancelStr & "true"
50310   Else
50320    NoCancelStr = NoCancelStr & "false"
50330  End If
50340
50350  If Options.PrintAfterSavingQueryUser > 0 Then
50360    sQueryUser = " /QueryUser " & Options.PrintAfterSavingQueryUser
50370   Else
50380    If LenB(Trim$(Options.PrintAfterSavingPrinter)) > 0 Then
50390        If Mid$(Options.PrintAfterSavingPrinter, 1, 2) = "\\" Then ' network printer
50400        sPrinter1 = " /OutputFile (" & Replace$(Options.PrintAfterSavingPrinter, "\", "\\") & ") "
50410       Else
50420        sPrinter1 = " /OutputFile (" & Replace$("\\spool\" & Options.PrintAfterSavingPrinter, "\", "\\") & ") "
50430      End If
50440     Else
50450      sQueryUser = " /QueryUser 1"
50460    End If
50470  End If
50480
50490  sMaxResolution = " dup /MaxResolution " & Options.PrintAfterSavingMaxResolution & " put"
50500  sMaxResolution = ""
50510
50520  AddParamCommand "mark " & NoCancelStr & " /BitsPerPixel " & PrintAfterSavingBitsPerPixel(Options.PrintAfterSavingBitsPerPixel) & _
   sQueryUser & sPrinter1 & _
  " /UserSettings 1 dict dup /DocumentName (" & Replace$("A", "\", "\\") & ") put" & sMaxResolution & " (mswinpr2) finddevice putdeviceprops setdevice"
50550
50560  If Options.PrintAfterSavingDuplex = 1 Then
50570   If Options.PrintAfterSavingTumble = 1 Then
50580     AddParamCommand "<< /Duplex true /Tumble true >> setpagedevice"
50590    Else
50600     AddParamCommand "<< /Duplex true /Tumble false >> setpagedevice"
50610   End If
50620  End If
50630
50640  AddParamCommands
50650
50660  Dim AdditionalFiles As Collection
50670  Set AdditionalFiles = New Collection
50680  AdditionalFiles.Add PDFDocInfoFile
50690  AdditionalFiles.Add StampFile
50700
50710  AddInputFiles InfoSpoolFileName, AdditionalFiles
50720
50730  ShowParams
50740  CallGhostscript "mswinpr2"
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "CheckForPrintingAfterSaving")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Public Sub ConvertFile(InputFilename As String, OutputFilename As String, Optional SubFormat As String = "")
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim Ext As String, ivgf As Boolean, inFile As String, File As String, psFileName As String
50020  Dim InfoSpoolFileName As String, PDFDocInfoFile As String, StampFile As String, PDFDocViewFile As String
50030  Dim PDFDocInfo As tPDFDocInfo, tDate As Date
50040  Dim PSHeader As tPSHeader, dateStr As String, strGUID As String
50050  Dim dateCreated As Date, dateAccessed As Date, dateWritten As Date
50060  Dim isf As clsInfoSpoolFile
50070
50080  IFIsPS = False
50090  If LenB(InputFilename) = 0 Then
50100   Exit Sub
50110  End If
50120  If FileExists(InputFilename) = False Then
50130   If LenB(InputFilename) > 0 Then
50140    MsgBox LanguageStrings.MessagesMsg14 & vbCrLf & vbCrLf & _
    "InputFile -IF" & vbCrLf & ">" & InputFilename & "<", vbExclamation + vbOKOnly
50160   End If
50170   Exit Sub
50180  End If
50190  ivgf = IsValidGraphicFile(InputFilename)
50200  If LenB(OutputFilename) > 0 Then
50210    tDate = Now
50220    dateStr = CStr(tDate)
50230    If IsPostscriptFile(InputFilename) = True Or ivgf Or IsPDFFile(InputFilename) Then
50240      If GsDllLoaded = 0 Then
50250       Exit Sub
50260      End If
50270      GsDllLoaded = LoadDLL(CompletePath(Options.DirectoryGhostscriptBinaries) & GsDll)
50280      If GsDllLoaded = 0 Then
50290       MsgBox LanguageStrings.MessagesMsg08
50300      End If
50310      inFile = InputFilename
50320      strGUID = GetGUID
50330      File = GetPDFCreatorSpoolDirectory & strGUID
50340      If ivgf Then
50350       psFileName = File & ".ps"
50360       If Image2PS(InputFilename, psFileName) Then
50370         inFile = psFileName
50380        Else
50390         IfLoggingWriteLogfile "ConvertFile: There is a problem converting '" & InputFilename & "'!"
50400         Exit Sub
50410       End If
50420      End If
50430      InfoSpoolFileName = CreateInfoSpoolFile(inFile, File & ".inf", , , , , , , , False)
50440      If IsPostscriptFile(inFile) = True Then
50450        PSHeader = GetPSHeader(inFile)
50460        If LenB(PSHeader.CreationDate.Comment) > 0 Then
50470         dateStr = FormatPrintDocumentDate(PSHeader.CreationDate.Comment)
50480        End If
50490       Else
50500        If GetFileTimes(inFile, dateCreated, dateAccessed, dateWritten, True) Then
50510         dateStr = CStr(dateCreated)
50520        End If
50530      End If
50540     Else
50550      InfoSpoolFileName = InputFilename
50560      inFile = InputFilename
50570      If LenB(InfoSpoolFileName) > 0 Then
50580       Set isf = New clsInfoSpoolFile
50590       isf.ReadInfoFile InfoSpoolFileName
50600       If LenB(isf.FirstSpoolFileName) > 0 Then
50610        If IsPostscriptFile(isf.FirstSpoolFileName) = True Then
50620          PSHeader = GetPSHeader(isf.FirstSpoolFileName)
50630          If LenB(PSHeader.CreationDate.Comment) > 0 Then
50640            dateStr = FormatPrintDocumentDate(PSHeader.CreationDate.Comment)
50650           Else
50660            If GetFileTimes(isf.FirstSpoolFileName, dateCreated, dateAccessed, dateWritten, True) Then
50670             dateStr = CStr(dateCreated)
50680            End If
50690          End If
50700         Else
50710          If GetFileTimes(isf.FirstSpoolFileName, dateCreated, dateAccessed, dateWritten, True) Then
50720           dateStr = CStr(dateCreated)
50730          End If
50740        End If
50750       End If
50760      End If
50770    End If
50780
50790    SplitPath OutputFilename, , , , , Ext
50800
50810    Set isf = New clsInfoSpoolFile
50820    isf.ReadInfoFile InfoSpoolFileName
50830    With PDFDocInfo
50840     If Len(Trim$(Options.StandardTitle)) > 0 Then
50850       .Author = GetSubstFilename(InfoSpoolFileName, RemoveLeadingAndTrailingQuotes(Trim$(Options.StandardTitle)), , , True)
50860      Else
50870       .Author = GetSubstFilename(InfoSpoolFileName, Options.SaveFilename, , , True)
50880     End If
50890     If Options.UseStandardAuthor = 1 Then
50900       .Creator = GetSubstFilename(InfoSpoolFileName, RemoveLeadingAndTrailingQuotes(Trim$(Options.StandardAuthor)), True, , True)
50910      Else
50920       If IsPostscriptFile(isf.FirstSpoolFileName) Then
50930         .Creator = GetDocUsernameFromPostScriptFile(isf.FirstSpoolFileName, False)
50940        Else
50950         .Creator = isf.FirstUserName
50960       End If
50970     End If
50980     If Len(Trim$(Options.StandardKeywords)) > 0 Then
50990      .Keywords = GetSubstFilename(InfoSpoolFileName, RemoveLeadingAndTrailingQuotes(Trim$(Options.StandardKeywords)), , , True)
51000     End If
51010     If Len(Trim$(Options.StandardSubject)) > 0 Then
51020      .Subject = GetSubstFilename(InfoSpoolFileName, RemoveLeadingAndTrailingQuotes(Trim$(Options.StandardSubject)), , , True)
51030     End If
51040
51050     .CreationDate = GetDocDate(Options.StandardCreationdate, Options.StandardDateformat, dateStr)
51060     .ModifyDate = GetDocDate(Options.StandardModifydate, Options.StandardDateformat, dateStr)
51070     .Creator = App.EXEName & " Version " & App.Major & "." & App.Minor & "." & App.Revision
51080    End With
51090
51100    PDFDocInfoFile = CreatePDFDocInfoFile(InfoSpoolFileName, PDFDocInfo)
51110    StampFile = CreateStampFile(InfoSpoolFileName)
51120    If Options.PDFPageLayout > 0 Or Options.PDFPageMode > 0 Or Options.PDFStartPage > 1 Then
51130     PDFDocViewFile = CreatePDFDocViewFile(InfoSpoolFileName, Options.PDFPageLayout, Options.PDFPageMode, Options.PDFStartPage)
51140    End If
51150
51161    Select Case UCase$(Ext)
          Case "PDF"
51181      Select Case UCase(SubFormat)
            Case "PDF/A-1B"
51200        CallGScript InfoSpoolFileName, OutputFilename, Options, PDFAWriter, PDFDocInfoFile, StampFile, PDFDocViewFile, PDFA1b
51210       Case "PDF/A-2B"
51220        CallGScript InfoSpoolFileName, OutputFilename, Options, PDFAWriter, PDFDocInfoFile, StampFile, PDFDocViewFile, PDFA2b
51230       Case "PDF/X"
51240        CallGScript InfoSpoolFileName, OutputFilename, Options, PDFXWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51250       Case Else
51260        CallGScript InfoSpoolFileName, OutputFilename, Options, PDFWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51270      End Select
51280     Case "PNG"
51290      CallGScript InfoSpoolFileName, OutputFilename, Options, PNGWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51300     Case "JPG"
51310      CallGScript InfoSpoolFileName, OutputFilename, Options, JPEGWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51320     Case "BMP"
51330      CallGScript InfoSpoolFileName, OutputFilename, Options, BMPWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51340     Case "PCX"
51350      CallGScript InfoSpoolFileName, OutputFilename, Options, PCXWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51360     Case "TIF"
51370      CallGScript InfoSpoolFileName, OutputFilename, Options, TIFFWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51380     Case "PS"
51390      CallGScript InfoSpoolFileName, OutputFilename, Options, PSWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51400     Case "EPS"
51410      CallGScript InfoSpoolFileName, OutputFilename, Options, EPSWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51420     Case "TXT"
51430      CallGScript InfoSpoolFileName, OutputFilename, Options, TXTWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51440     Case "PCL"
51450      CallGScript InfoSpoolFileName, OutputFilename, Options, PCLWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51460     Case "PSD"
51470      CallGScript InfoSpoolFileName, OutputFilename, Options, PSDWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51480     Case "RAW"
51490      CallGScript InfoSpoolFileName, OutputFilename, Options, RAWWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51500     Case "SVG"
51510      CallGScript InfoSpoolFileName, OutputFilename, Options, SVGWriter, PDFDocInfoFile, StampFile, PDFDocViewFile
51520    End Select
51530
51540    KillFile InfoSpoolFileName
51550    KillFile PDFDocInfoFile
51560    KillFile StampFile
51570
51580    ConvertedOutputFilename = OutputFilename
51590    ReadyConverting = True
51600    Exit Sub
51610   Else
51620    If FileExists(InputFilename) = True Then
51630     If IsPostscriptFile(InputFilename) = True Then
51640       IFIsPS = True
51650      Else
51660       MsgBox LanguageStrings.MessagesMsg06 & vbCrLf & vbCrLf & InputFilename
51670     End If
51680    End If
51690  End If
51700  DoEvents
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "ConvertFile")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Public Function GetGhostscriptVersion() As clsGhostscript
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim gsRev As String, tStr As String, Major As Long, Minor As Long, Ghostscript As clsGhostscript
50020  Set Ghostscript = New clsGhostscript
50030  gsRev = CStr(GSRevision.intRevision)
50040  If Len(gsRev) >= 3 Then
50050   tStr = Mid(gsRev, Len(gsRev) - 1, 2)
50060   If IsNumeric(tStr) Then
50070    Minor = CLng(tStr)
50080   End If
50090   tStr = Mid(gsRev, 1, Len(gsRev) - 2)
50100   If IsNumeric(tStr) Then
50110    Major = CLng(tStr)
50120   End If
50130   Ghostscript.VersionMajor = Major
50140   Ghostscript.VersionMinor = Minor
50150  End If
50160  Set GetGhostscriptVersion = Ghostscript
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "GetGhostscriptVersion")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Function GetGhostscriptResourceString() As String
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim tStr As String, Ghostscript As clsGhostscript
50020  Set Ghostscript = GetGhostscriptVersion
50030  If (Ghostscript.VersionMajor < 8) Or (Ghostscript.VersionMajor = 8 And Ghostscript.VersionMinor <= 62) Then
50040   If LenB(LTrim(Options.DirectoryGhostscriptFonts)) > 0 Then
50050    tStr = tStr & ";" & LTrim(Options.DirectoryGhostscriptFonts)
50060   End If
50070   If LenB(LTrim(Options.DirectoryGhostscriptResource)) > 0 Then
50080    tStr = tStr & ";" & LTrim(Options.DirectoryGhostscriptResource)
50090   End If
50100  End If
50110  GetGhostscriptResourceString = tStr
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modGhostScript", "GetGhostscriptResourceString")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function
